/* GUI definitions */

// --------------------- GUI style definitions - Element
const colors_element=
{
	white : gui.rgb(255, 255, 255),
	yellow: gui.rgb(254, 222, 88),
	dgray : gui.rgb(77, 77, 77),
	red   : gui.rgb(255, 26, 0),
	dred  : gui.rgb(48, 0, 0),
	ltblue: gui.rgb(129, 169, 191),
	dblue : gui.rgb(11, 0, 73),

	labelON : gui.rgb( 26, 117, 187),
	labelOFF: gui.rgb(180, 180, 180)
};
const fonts_element=
{
	clock        : "myriad_pro_bi20",
	showText     : "myriad_pro_bi10",
	showTextsmall: "myriad_pro_bi9",
	caption      : "myriad_pro_10",
	src          : "myriad_pro_bi12",
	value        : "myriad_pro_8"
};
const styles_element=
{
	date    : {font:"myriad_pro_bi11",     color:gui.rgb(26, 117, 187), align:gui.CENTER},
	time    : {font:"myriad_pro_bi20",     color:gui.rgb(26, 117, 187), align:gui.RIGHT},
	time_big: {font:'myriad_pro_bi48_num', color:gui.rgb(26, 117, 187), align:gui.RIGHT},
	ampm    : {font:"myriad_pro_bi8" ,     color:gui.rgb(26, 117, 187), align:gui.RIGHT},
	ampm_big: {font:"myriad_pro_bi11",     color:gui.rgb(26, 117, 187)},
	info    : {font:"myriad_pro_8",        color:colors_element.red, bgcolor:colors_element.dred, align:gui.CENTER, valign:gui.CENTER},
	tmdn    : {font:"myriad_pro_bi20",     color:colors_element.red,   align:gui.LEFT},
	tmup    : {font:"myriad_pro_bi20",     color:gui.rgb(26, 117, 187), align:gui.LEFT},
	tmup_dot: {font:"myriad_pro_bi20",     color:gui.rgb(26, 117, 187), align:gui.RIGHT, valign: gui.BOTTOM},
	tmup_aux: {font:"myriad_pro_i8",       color:gui.rgb(26, 117, 187)},
	tmdn_aux: {font:"myriad_pro_i8",       color:colors_element.red},
	tmdn_lbl: {font:"myriad_pro_8",        color:gui.rgb(180, 180, 180), align:gui.CENTER},
	tmup_lbl: {font:"myriad_pro_8",        color:gui.rgb(180, 180, 180), align:gui.CENTER},
	show_lbl: {font:"myriad_pro_8",        color:gui.rgb(180, 180, 180), align:gui.CENTER},
	pg_title: {font:"myriad_pro_10",       color:gui.rgb(26, 117, 187), align:gui.CENTER},
	phnumber: {font:"myriad_pro_9",        color:colors_element.yellow, align:gui.LEFT},
	sknob   : {font:"myriad_pro_8",        color:gui.rgb(180, 180, 180), align:gui.CENTER}
};
// common control properties
const props_element=
{
	value       : {font:fonts_element.value, color:colors_element.ltblue, align:gui.CENTER},
	value_left  : {font:fonts_element.value, color:colors_element.ltblue, align:gui.LEFT},
	value_right : {font:fonts_element.value, color:colors_element.ltblue, align:gui.RIGHT},
	value_yellow: {font:fonts_element.value, color:colors_element.yellow, align:gui.LEFT},
	src : {font:fonts_element.src, color:colors_element.yellow, align:gui.CENTER},
	feed: {font:fonts_element.src, color:colors_element.yellow, align:gui.LEFT, valign: gui.CENTER},
	src_small: {font:fonts_element.showTextsmall, color:colors_element.yellow, align:gui.CENTER},
	channel: {font:fonts_element.caption, color:colors_element.ltblue, align:gui.CENTER},
	monsrc : {font:"myriad_pro_bi11", color:colors_element.yellow, align:gui.CENTER},
	extsrc : {font:"myriad_pro_10", color:colors_element.yellow, align:gui.LEFT},
	clock  : {font:fonts_element.clock, color:colors_element.yellow, align:gui.CENTER},
	clock_right: {font:fonts_element.clock, color:colors_element.yellow, align:gui.RIGHT},
	sknob_blue : {font:fonts_element.value, color:colors_element.yellow, align:gui.CENTER, valign:gui.CENTER},
	value9: {font:"myriad_pro_9", color:colors_element.ltblue, align:gui.CENTER},
	value9_left : {font:"myriad_pro_9", color:colors_element.ltblue, align:gui.LEFT},
	value9_right: {font:"myriad_pro_9", color:colors_element.ltblue, align:gui.RIGHT},
	sknob_title : {font:fonts_element.value, color:colors_element.dgray, align:gui.CENTER},

// Color Properties for focus
	ChoptFocused: {color:colors_element.red},    // Focused Text on Channel Summary screen
	ChoptInactive:{color:colors_element.ltblue}, // Not Focused Text on Channel Summary screen
	Focused : {color:colors_element.yellow},      // Focused Text on Screens
	Inactive: {color:colors_element.ltblue},      // Inactive Text on Screens
	Changed : {color:colors_element.red},          // Changed Text on Screens
	list:
	{
		font: fonts_element.value,

	// text colors
		color:      colors_element.ltblue,
		acolor:     colors_element.yellow,
		dcolor:     gui.rgb(128, 128, 128),
		bgcolor:    colors_element.dblue,
		selcolor:   gui.rgb(167, 212, 172),
		selacolor:  colors_element.yellow,
		seldcolor:  gui.rgb(128, 128, 128),
		selbgcolor: gui.rgb(108, 128, 113),

	// scrollbar
		barw: 0,
		barcolor: colors_element.ltblue,
	// border
		bordercolor: colors_element.ltblue,
		border: 0,

	// icons
		icosrc: "img/list_icon.png",
		icow:   14,

		sort: 0
	}
};

// --------------------- GUI style definitions - Fusion

function fontdef(style, sz)
{
	if(0)
		return "TitilliumWeb-"+style+"_"+sz;
	else
		return "ft:TitilliumWeb-"+style+".ttf:"+sz;
}
function fontSemiBold(sz) {return fontdef("SemiBold", sz);}
function fontRegular (sz) {return fontdef("Regular",  sz);}
function fontBold    (sz) {return fontdef("Bold",     sz);}
function fontLight   (sz) {return fontdef("Light",    sz);}

const colors_fusion=
{
	white : gui.rgb(255, 255, 255),
	yellow: gui.rgb(254, 222, 88),
	lyellow: gui.rgb(0xD7, 0xFF, 0x09),
	lgray : gui.rgb(159, 159, 159),
	dgray : gui.rgb(77, 77, 77),
	lblack: gui.rgb(27, 27, 27),
	red   : gui.rgb(255, 0, 0),
	dred  : gui.rgb(48, 0, 0),
	ltblue: gui.rgb(129, 169, 191),
	dblue : gui.rgb(11, 0, 73),
	black : gui.rgb(0,0,0),
	labelON : gui.rgb(0xD7, 0xFF, 0x09), // lyellow,
	labelOFF: gui.rgb(159, 159, 159) // lgray
};
const fonts_fusion=
{
	clock        : fontSemiBold(20),
	showText     : fontSemiBold(10),
	showTextsmall: fontSemiBold(8),
	caption      : fontSemiBold(10),
	src          : fontSemiBold(10),
	value        : fontSemiBold(8)
};

const styles_fusion=
{
	date    : {font:fontRegular(13) , color:colors_fusion.lyellow, align:gui.CENTER, valign:gui.MIDDLE},
	weekday : {font:fontSemiBold(20), color:colors_fusion.lyellow, align:gui.CENTER, valign:gui.MIDDLE},
	time    : {font:fontSemiBold(24), color:colors_fusion.lyellow, align:gui.RIGHT, valign:gui.MIDDLE},
	time_big: {font:fontSemiBold(65), color:colors_fusion.lyellow, align:gui.RIGHT, valign:gui.MIDDLE},
	ampm    : {font:fontRegular(11), color:colors_fusion.lyellow, align:gui.LEFT, valign:gui.BOTTOM},
	ampm_big: {font:fontRegular(20), color:colors_fusion.lyellow, align:gui.LEFT, valign:gui.BOTTOM},
	info    : {font:fontRegular(14), color:colors_fusion.red, bgcolor:colors_fusion.dred, align:gui.CENTER, valign:gui.MIDDLE},
	tmdn    : {font:fontSemiBold(24), color:colors_fusion.lyellow, align:gui.LEFT, valign:gui.BOTTOM},
	tmup    : {font:fontSemiBold(24), color:colors_fusion.lyellow, align:gui.LEFT, valign:gui.BOTTOM},
	pg_title: {font:fontRegular(12), color:colors_fusion.lyellow, align:gui.CENTER, valign:gui.MIDDLE},
	sknob   : {font:fontBold(10), color:colors_fusion.lblack, align:gui.CENTER, valign:gui.MIDDLE},
	sknoblbl: {font:fontSemiBold(8), color:colors_fusion.lyellow, align:gui.CENTER, valign:gui.MIDDLE},
	value   : {font:fontSemiBold(8), color:colors_fusion.white, align:gui.CENTER, valign:gui.MIDDLE},
// XXX: Not sure why style.label is used at all, color is changed on first focus
	label   : {font:fontSemiBold(8), color:colors_fusion.white, align:gui.CENTER, valign:gui.MIDDLE},
	lmain_lt: {font:fontSemiBold(14), color:colors_fusion.black, align:gui.LEFT, valign:gui.MIDDLE},
	lmain_rt: {font:fontSemiBold(14), color:colors_fusion.black, align:gui.RIGHT, valign:gui.MIDDLE},
	lmain_medium_rt: {font:fontSemiBold(11), color:colors_fusion.black, align:gui.RIGHT, valign:gui.MIDDLE},
	monitor_title:  {font:fontSemiBold(11), color:colors_fusion.black, align:gui.LEFT, valign:gui.MIDDLE},
	lext_lt : {font:fontBold(12), color:colors_fusion.black, align:gui.LEFT, valign:gui.MIDDLE},
	lext_rt : {font:fontBold(12), color:colors_fusion.black, align:gui.RIGHT, valign:gui.MIDDLE}
};

// common control properties
const props_fusion=
{
	value : {font:fonts_fusion.value, color:colors_fusion.white, align:gui.CENTER},
	value_left : {font:fonts_fusion.value, color:colors_fusion.lyellow, align:gui.LEFT},
	value_left_medium : {font:fontSemiBold(10), color:colors_fusion.lyellow, align:gui.LEFT, valign:gui.MIDDLE},
	value_right : {font:fonts_fusion.value, color:colors_fusion.ltblue, align:gui.RIGHT},
	value_yellow : {font:fonts_fusion.value, color:colors_fusion.yellow, align:gui.LEFT},
	src : {font:fonts_fusion.src, color:colors_fusion.lyellow, align:gui.CENTER},
	src_left : {font:fonts_fusion.src, color:colors_fusion.lyellow, align:gui.LEFT},
	feed: {font:fonts_fusion.src, color:colors_fusion.yellow, align:gui.LEFT, valign: gui.CENTER},
	src_small : {font:fonts_fusion.showTextsmall, color:colors_fusion.yellow, align:gui.CENTER},
	channel : {font:fonts_fusion.caption, color:colors_fusion.lyellow, align:gui.CENTER},
	monsrc : {font:fontBold(10), color:colors_fusion.yellow, align:gui.CENTER},
	extsrc : {font:fontSemiBold(10), color:colors_fusion.yellow, align:gui.LEFT},
	clock : {font:fonts_fusion.clock, color:colors_fusion.yellow, align:gui.CENTER},
	clock_right : {font:fonts_fusion.clock, color:colors_fusion.lyellow, align:gui.RIGHT},
	sknob_blue : {font:fonts_fusion.value, color:colors_fusion.lyellow, align:gui.CENTER, valign:gui.MIDDLE},
	value9 : {font:fontSemiBold(9), color:colors_fusion.white, align:gui.CENTER},
	value9_left : {font:fontSemiBold(9), color:colors_fusion.white, align:gui.LEFT},
	value9_right : {font:fontSemiBold(9), color:colors_fusion.white, align:gui.RIGHT},
	sknob_title : {font:fonts_fusion.value, color:colors_fusion.dgray, align:gui.CENTER},
	meter_scale : {font:fontLight(9), color:colors_fusion.white, align:gui.CENTER, valign:gui.MIDDLE},
// Color Properties for focus
	Focused : {color:colors_fusion.lyellow},    // Focused Text on Screens
	Inactive: {color:colors_fusion.white},      // Inactive Text on Screens
	Changed : {color:colors_fusion.red},        // Changed Text on Screens
	list:
	{
		font:  fontSemiBold(10),

	// text color
		color:      colors_fusion.lgray,
		acolor:     colors_fusion.lyellow,
		dcolor:     gui.rgb(128, 128, 128),
		bgcolor:    gui.rgb(23,23,22),
		bgcoloralt: gui.rgb(38,38,37),
		selcolor:   colors_fusion.dgray,
		selacolor:  colors_fusion.red,
		seldcolor:  colors_fusion.lyellow,
		selbgcolor: colors_fusion.lyellow,

	// scrollbar
		barw: 0,
		barcolor: colors_fusion.lyellow,
	// border
		bordercolor: colors_fusion.lyellow,
		border: 0,

	// icons
		icosrc: "img/svg/list_icon.svg",
		icow:   14,

		sort: 0
	}
};

// I hope for unification one day, but until then...
var color, font, style, prop;
