// Indicators
const keyPhoneNum=['0','1','2','3','4','5','6','7','8','9','*','#'];
const keyPhoneSip=['0','1','2','3','4','5','6','7','8','9','.','@'];
const keyPhoneTxt=['@0',':1','ABC2','DEF3','GHI4','JKL5','MNO6','PQRS7','TUV8','WXYZ9','()*','.,#'];
var gui_indi_show_loading=false;
var gui_indi=
{
	setShowName: function(name, loading)
	{
		this.show.setText(name);
		this.show.indLoading(loading);
		gui_indi_show_loading=loading;
		if(gui_indi_show_loading)
			object_blinker.add(this.show, function(x){return gui_indi_show_loading;}, true, null, null);
	},
	showWarning: function(txt)
	{
		if(txt=="")
			this.lblInfo.hide();
		else
		{
			this.lblInfo.setProps({color:color.red, bgcolor:color.dred});
			this.lblInfo.setText(txt);
			this.lblInfo.show();
		}
	},
	showInfo: function(txt)
	{
		if(txt=="")
			this.lblInfo.hide();
		else
		{
			this.lblInfo.setProps({color:color.ltblue, bgcolor:color.dblue});
			this.lblInfo.setText(txt);
			this.lblInfo.show();
		}
	},
/* ------ * In-Ring frame * ------ */
	inringOpen: function(id, number)
	{
		var ring=this.inring;

		ring.owner=id;
		ring.nr.setText(number);
		ring.show();
	},
	inringClose: function(id)
	{
		var ring=this.inring;
	
		if(ring.owner!=id) return;
		ring.owner=null;
		ring.hide();
	},
/* ------ * Dial-Out frame * ------ */
	numpadGrab: function(id)
	{
		var pad=this.numpad;

		if(pad.owner!=null)
		{
			if(pad.owner!=id)
			{
				if('onPadClose' in pad.owner)
					pad.owner.onPadClose();
			}
		}
		pad.owner=id;
	/* clear pad */
		pad.anto=host.clearTimeout(pad.anto);
		pad.moto=host.clearTimeout(pad.moto);
		if(pad.cnum!="")
		{
			pad.onum=pad.cnum;
			pad.cnum="";
		}
		pad.nr.setText(pad.cnum);
		pad.show();
	},
	numpadRelease: function(id)
	{
		var pad=this.numpad;

		if(pad.owner!=id) return;
		pad.owner=null;
		pad.hide();
	},
	numpadGetNumber: function(id)
	{
		var pad=this.numpad;

		if(pad.owner==null) return "";
		return pad.cnum;
	},
	numpadRecall: function(id)
	{
		var pad=this.numpad;

		if(pad.owner!=id) return;
		pad.cnum=pad.onum;
		pad.nr.setText(pad.cnum);
	},
/*
** gui_indi.numpadAppend
**
** appends key's symbol to dialout number
*/
	numpadAppend: function(key)
	{
		var pad=this.numpad;

	/* notify owner so it can play DTMF if it wish */
		if('onPadKey' in pad.owner) pad.owner.onPadKey(key);
	/* add number */
		if(pad.cnum.length<28)
		{
			if(pad.mode==0) /* Numeric Mode */
				pad.cnum+=keyPhoneNum[key];
			else if(pad.mode==1) /* SIP Mode */
				pad.cnum+=keyPhoneSip[key];
			else /* Alpha Numeric Mode */
			{
				if(pad.anto==null || pad.anlk!=key || pad.cnum.length==0)
					pad.cnum+=keyPhoneTxt[key].charAt(0);
				else
				{
					var wolast=pad.cnum.substr(0, pad.cnum.length-1);
					var last=pad.cnum.substr(pad.cnum.length-1, 1);
					var npos=(keyPhoneTxt[key].indexOf(last, 0)+1)%keyPhoneTxt[key].length;

					pad.cnum=wolast+keyPhoneTxt[key].charAt(npos);
				}
				pad.anlk=key;
				pad.anto=host.resetTimeout(pad.anto, 1000, function(){this.anto=null;}, pad);
			}
			pad.nr.setText(pad.cnum);
		}
	},
/*
** gui_indi.numpadEvent
**
** called when numpad key is pressed/released, returns true if handled
** key's are:
** 0-9: '0'-'9'
**  10: '*'
**  11: '#'
**  12: <backspace>
**  13: <enter>
*/
	numpadEvent: function(key, down)
	{
		var pad=this.numpad;
		var pos;

		if(pad.owner==null) return false;
		pad.ipto=host.clearTimeout(pad.ipto);
		if(down)
		{
			if(key==12) /* backspace key */
			{
				if(pad.cnum.length>0)
				{
					pad.cnum=pad.cnum.substr(0, pad.cnum.length-1);
					pad.nr.setText(pad.cnum);
				}
				return true;
			}
			if(key==13)
			{
				if('onPadEnter' in pad.owner) pad.owner.onPadEnter();
				return true;
			}
		}
		if(!(key in keyPhoneNum)) return false;
		if(!down)
		{
			pad.indAnim(-1);
			if(key==11 && pad.moto!=null)
			{
				pad.moto=host.clearTimeout(pad.moto);
				if(pad.mode==0 && ('onPadEnter' in pad.owner)) /* # in numeric mode is enter */
					pad.owner.onPadEnter();
				else
					this.numpadAppend(key);
			}
			return true;
		}
	/* animate dialpad */
		pad.indAnim((key==0)?10:(key==11?key:key-1));
		if(key==11) // '#' changes mode
		{
			pad.moto=host.resetTimeout(pad.moto, 1000, function(){this.moto=null;this.mode=(this.mode+1)%3;this.indMode();}, pad);
			return true;
		}
		if(key==0 && pad.mode==0 && pad.cnum=="")
			pad.ipto=host.resetTimeout(pad.ipto, 1000, function(){this.ipto=null;if(this.cnum=="0") {this.cnum="+";this.nr.setText(pad.cnum);}}, pad);
	/* add to number */
		this.numpadAppend(key);
		return true;
	}
};

function Gui_CreateFusionIndicator(f, x, y, title)
{
	var ind;

	ind=gui.newLabel(f, x, y, 149, 40, "img/svg/indi_bg.svg", {font:fontRegular(18), color:gui.rgb(86,86,86), acolor:gui.rgb(35,36,38), align:gui.CENTER, valign:gui.MIDDLE})
	ind.setText(title);
	ind.setOn=function(on) {this.setIndex(on?1:0);}
	return ind;
}

/*
** Gui_CreateIndiSection
*/
function Gui_CreateIndiSection()
{
	var f, l;

	if(cfg_fusionUI)
	{
	// Annunciators
		gui_indi.onair =Gui_CreateFusionIndicator(gui_frames.indt, 0, 123, "ON AIR");
		gui_indi.pview =Gui_CreateFusionIndicator(gui_frames.indt, 0+163, 123, "PREVIEW");
		gui_indi.talk  =Gui_CreateFusionIndicator(gui_frames.indt, 0+163*2+2, 123, "TALK");
		gui_indi.record=Gui_CreateFusionIndicator(gui_frames.indt, 0+163*3+2, 123, "RECORD");

	// Show Profile Name
		l=gui.newLabel(gui_frames.cind, 0, 0, 60, 22, '', style.lmain_lt);
		l.setText("Profile");

		f=gui.newFrame(gui_frames.cind, 0, 25, 640, 42, "img/svg/show_label_bg.svg");
		gui_indi.show=gui.newLabel(f, 6, 6, 640-6*2, 42-2*6, '', {font:fontRegular(16), color:color.lyellow, align:gui.CENTER, valign:gui.MIDDLE});
		gui_indi.show.setText(cur_show_name);
		gui_indi.show.indLoading=function(loading) {this.setProp('color', loading?color.red:color.lyellow);};

	// Show Profile Changed
		l=gui.newLabel(gui_frames.cind, 640-65-22-2-10, 1, 65, 19, '', style.lmain_medium_rt);
		l.setText("Changed");
		gui_indi.showChanged=gui.newPicture(gui_frames.cind, 640-22, 3, 22, 14, "img/svg/indi_prof_changed.svg");

	// PhoneShow Change Waiting notification
		gui_indi.phShow=gui.newFrame(gui_frames.cind, 0, 220-27-10, 280, 27, "img/svg/dial-frame.svg");
		gui_indi.phShow.lbl=gui.newLabel(gui_indi.phShow, 280/2-225/2, 27/2-20/2, 225, 20, '', {font:fontSemiBold(10), color:color.red, align:gui.CENTER, valign:gui.MIDDLE});
		gui_indi.phShow.lbl.setText("New phone-show waiting...");
		gui_indi.phShow.hide();

	// Numpad for Dialing
		gui_indi.numpad=gui.newFrame(gui_frames.cind, 0, 220-27-10-27-10, 280, 27, "img/svg/dial-frame.svg");
		gui_indi.numpad.mi=gui.newLabel(gui_indi.numpad, 4, 27/2-12/2+2, 21, 12, '', {font:fontLight(7), color:color.white, align:gui.LEFT});
		gui_indi.numpad.anim_fr=gui.newFrame(gui_indi.numpad, 11+21, 3+1, 14, 19, "img/svg/dial-anim-bg.svg");
		gui_indi.numpad.anim=gui.newPicture(gui_indi.numpad.anim_fr, 0, 0, 4, 4, "img/svg/dial-anim.svg");
		gui_indi.numpad.anim.hide();
		gui_indi.numpad.nr=gui.newLabel(gui_indi.numpad, 11+21+15+2, 27/2-18/2, 280-(11+21+15+2)-6, 18, '', {font:fontSemiBold(10), color:color.lyellow, align:gui.LEFT});
		gui_indi.numpad.indMode=function() {this.mi.setText(phDialModes[this.mode]);};
		gui_indi.numpad.indAnim=function(pos)
		{
			if(pos==-1)
				this.anim.hide();
			else
			{
				this.anim.moveTo((pos%3)*5, Math.floor(pos/3)*5);
				this.anim.show();
			}
		};

	// Incoming call Frame
		gui_indi.inring=gui.newFrame(gui_frames.cind, 0, 220-27-10-27-10+30, 280, 27, "img/svg/ring-frame.svg");
		gui_indi.inring.phicon=gui.newFrame(gui_indi.inring, 6, 27/2-18/2, 18, 18, "img/svg/icon_ph.svg");
		gui_indi.inring.nr=gui.newLabel(gui_indi.inring, 6+18+2, 27/2-18/2, 280-(6+18+2)-6, 18, '', {font:fontSemiBold(10), color:color.red, align:gui.LEFT});

	// Information Label
		gui_indi.lblInfo=gui.newLabel(gui_frames.indt, 0, 0, 640, 20, '', {font:fontRegular(14), color:color.red, bgcolor:color.dred, align:gui.CENTER, valign:gui.MIDDLE});
		gui_indi.lblInfo.hide();

	// UI Functions
		gui_indi.setOnAir =function(on) {this.onair .setOn(on);};
		gui_indi.setPview =function(on) {this.pview .setOn(on);};
		gui_indi.setTalk  =function(on) {this.talk  .setOn(on);};
		gui_indi.setRecord=function(on) {this.record.setOn(on);};
		gui_indi.setDelay =function(on) {};
		gui_indi.setShowChanged=function(on) {this.showChanged.setIndex(on?1:0);},
		gui_indi.setPhoneShowWaiting=function(on) {this.phShow.show(on);};
	}
	else
	{
	// Annunciators
		gui_indi.onair=gui.newPicture(gui_frames.indl,  26, 44+(26+5)*0, 96, 26, "img/dk_onair.png");
		gui_indi.pview=gui.newPicture(gui_frames.indl, 134, 44+(26+5)*0, 96, 26, "img/dk_preview.png");
		gui_indi.talk =gui.newPicture(gui_frames.indl,  26, 44+(26+5)*1, 97, 26, "img/dk_talk.png");
		gui_indi.delay=gui.newPicture(gui_frames.indl, 134, 44+(26+5)*1, 96, 26, "img/dk_delay.png");

	// Show Profile Name
		f=gui.newFrame(gui_frames.indr, 39, 48, 179, 25, "img/show.png");
		gui_indi.show=gui.newLabel(f, 7, 4, 165, 16, '', {font:font.showTextsmall, color:color.yellow, align:gui.CENTER});
		gui_indi.show.setText(cur_show_name);
		gui_indi.show.indLoading=function(loading) {this.setProp('color', loading?color.red:color.yellow);};

	// Show Profile Changed
		l=gui.newLabel(gui_frames.indr, 136, 35, 50, 11, '', style.show_lbl);
		l.setText("CHANGED");
		gui_indi.showChanged=gui.newPicture(gui_frames.indr, 190, 36, 11, 12, "img/leds.png");

	// Record Mode Indication
		l=gui.newLabel(gui_frames.indr, 74, 35, 41, 11, '', style.show_lbl);
		l.setText("RECORD");
		gui_indi.record=gui.newPicture(gui_frames.indr, 59, 36, 11, 12, "img/leds.png");

	// PhoneShow Change Waiting notification
		gui_indi.phShow=gui.newLabel(gui_frames.indl, 26, 165, 205, 16, '', {font:"myriad_pro_bi10", color:color.red, align:gui.CENTER});
		gui_indi.phShow.setText("New phone-show waiting...");
		gui_indi.phShow.hide();

	// Numpad for Dialing
		gui_indi.numpad=     gui.newFrame(gui_frames.indl,   30, 48+(26+5)*2, 205, 26, "img/dial-frame.png");
		gui_indi.numpad.mi=  gui.newPicture(gui_indi.numpad, 11, 19, 11, 5, "img/dial-mode.png");
		gui_indi.numpad.nr=  gui.newLabel(gui_indi.numpad,   23,  5, 170, 15, '', style.phnumber);
		gui_indi.numpad.anim=gui.newPicture(gui_indi.numpad,  8,  5, 4, 4, "img/dial-anim.png");
		gui_indi.numpad.anim.hide();
		gui_indi.numpad.indMode=function() {this.mi.setIndex(-1, this.mode);};
		gui_indi.numpad.indAnim=function(pos)
		{
			if(pos==-1)
				this.anim.hide();
			else
			{
				this.anim.moveTo(10+(pos%3)*4, 3+Math.floor(pos/3)*4);
				this.anim.show();
			}
		};

	// Incoming call Frame
		gui_indi.inring   =gui.newFrame(gui_frames.indl, 30, 48+(26+5)*3, 205, 26, "img/ring-frame.png");
		gui_indi.inring.nr=gui.newLabel(gui_indi.inring, 23, 5, 170, 15, '', style.phnumber);

	// User Logo
		host.defineUserLogo("logo.png", 129, 97);
		gui_indi.logo=gui.newFrame(gui_frames.indr, 64, 81, 129, 97, "*img/logo.png");

// Information Label
		gui_indi.lblInfo=gui.newLabel(gui_frames.main, 56, 480, 328, 18, '', style.info);
		gui_indi.lblInfo.hide();

	// UI Functions
		gui_indi.setOnAir =function(on) {this.onair .setIndex(on?1:0);};
		gui_indi.setPview =function(on) {this.pview .setIndex(on?1:0);};
		gui_indi.setTalk  =function(on) {this.talk  .setIndex(on?1:0);};
		gui_indi.setRecord=function(on) {this.record.setIndex(on?2:0);};
		gui_indi.setDelay =function(on) {this.delay .setIndex(on?1:0);};
		gui_indi.setShowChanged=function(on) {this.showChanged.setIndex(on?1:0);},
		gui_indi.setPhoneShowWaiting=function(on) {this.phShow.show(on);};
	}

// Numpad Init
	gui_indi.numpad.cnum="";
	gui_indi.numpad.onum="";
	gui_indi.numpad.anto=null;
	gui_indi.numpad.anlk=0;
	gui_indi.numpad.mode=0;
	gui_indi.numpad.moto=null;
	gui_indi.numpad.ipto=null;
	gui_indi.numpad.owner=null;
	gui_indi.numpad.indMode();
	gui_indi.numpad.hide();
// Inring Init
	gui_indi.inring.owner=null;
	gui_indi.inring.hide();
}
