// Soft-Knobs
var soft_knobs={};

/*
	sknobsSetOne(4, {angleNrm:this.list.selection/(this.list.count-1)});
		sknobsSetOne(soft_knob_idx, {angle:angl});

		sknobsShow([
			{enabled: true, rot: "RETURN A", push: "OFF"},
			{enabled: true, rot: "ASSIGN", push: "TAKE"},
			{enabled: true, rot: "RETURN B", push: "OFF"},
			{enabled: true, rot: "ASSIGN", push: "TAKE"},
			{enabled: false},
			{enabled: true, rot: "SELECT", push: "PREVIEW"}
		]);
		sknobsSetOne(0, {angleNrm:0});
		sknobsSetOne(3, {angleNrm:0});
		sknobsHide();

*/
// ------------------------- * Soft-Knob Section * -------------------------

function sknobsListNrmPos(list)
{
	var num;

	num=list.count;
	if(num<=1)
		return 0;
	else
		return list.selection/(num-1);
}

/*
** sknobsShow
*/
function sknobsShow(props)
{
	var n, num, p, kn;
	var title;

	soft_knobs.setTitle(('title' in props)?props.title:"SOFT CONTROLS");
// decide on number of knobs
	if(props.length<6)
	{
	// 3 knob variant
		soft_knobs.frm6.hide();
		soft_knobs.frm3.show();
		num=3;
		for(n=0; n<6; n++)
		{
			soft_knobs.sknob[n].enabled=false;
			soft_knobs.sknob[n].list=null;
		}
	}
	else
	{
	// 6 knob variant
		soft_knobs.frm3.hide();
		soft_knobs.frm6.show();
		num=6;
		for(n=6; n<9; n++)
		{
			soft_knobs.sknob[n].enabled=false;
			soft_knobs.sknob[n].list=null;
		}
	}
// set knob properties
	for(n=0; n<num; n++)
	{
		if(!(n in props)) break;
		p=props[n];
		kn=soft_knobs.sknob[num==6?n:n+6];

		kn.enabled=(('enabled' in p) && p.enabled);
		kn.knbg.setIndex(kn.enabled?0:2);
		kn.idx=0;
		if('rot' in p)
		{
			kn.rotlb.setText(p.rot);
			kn.idx|=1;
		}
		if('push' in p)
		{
			kn.pushlb.setText(p.push);
			kn.idx|=2;
		}
		kn.setFn(kn.idx);
		kn.list=('list' in p)?p.list:null;
		if(kn.list) kn.kn.setAngleNrm(sknobsListNrmPos(kn.list));
		kn.enter=('enter' in p) && p.enter;
		kn.jog=('jog' in p) && p.jog;
		kn.updn=('updn' in p) && p.updn;
		kn.ltrt=('ltrt' in p) && p.ltrt;
		kn.knob=('knob' in p) && p.knob;
		kn.chopt=('chopt' in p) && p.chopt;
	}

	gui_SknobsShow();
}

/*
** sknobsHide
*/
function sknobsHide()
{
	gui_SknobsHide();
}

/*
** sknobsSet
*/
function sknobsSet(props)
{
	var n, p, idx, kn;

	for(n=0; n<9; n++)
	{
		if(!(n in props)) continue;
		p=props[n];
		kn=soft_knobs.sknob[n];

		if(('enabled' in p) && kn.enabled!=p.enabled)
		{
			kn.enabled=p.enabled;
			kn.knbg.setIndex(kn.enabled?0:2);
		}

	// values
		if('angle' in p)
			kn.kn.setAngle(p.angle);
		else if('angleNrm' in p)
			kn.kn.setAngleNrm(p.angleNrm);
		if(kn.enabled)
		{
			if('down' in p)
				kn.knbg.setIndex(p.down?1:0);
		}
	// bindings
		if('list' in p)
		{
			kn.list=p.list;
			if(kn.list) kn.kn.setAngleNrm(sknobsListNrmPos(kn.list));
		}
		if('enter' in p) kn.enter=p.enter?true:false;
		if('jog' in p) kn.jog=p.jog?true:false;
		if('updn' in p) kn.updn=p.updn?true:false;
		if('ltrt' in p) kn.ltrt=p.ltrt?true:false;
		if('knob' in p) kn.knob=p.knob?true:false;
		if('chopt' in p) kn.chopt=p.chopt?true:false;

	// labels
		idx=kn.idx;
		if('rot' in p)
		{
			if(p.rot!=null)
			{
				kn.rotlb.setText(p.rot);
				idx|=1;
			}
			else if(idx&1)
				idx-=1;
		}
		if('push' in p)
		{
			if(p.push!=null)
			{
				kn.pushlb.setText(p.push);
				idx|=2;
			}
			else if(idx&2)
				idx-=2;
		}
		if(idx!=kn.idx) kn.setFn(kn.idx=idx);
	}
}

/*
** sknobsSetOne
*/
function sknobsSetOne(n, props)
{
	var v=[];
	v[n]=props;
	sknobsSet(v);
}

function sknobsFindSpecial(special)
{
	var n, kn;

	for(n=0; n<soft_knobs.sknob.length; n++)
	{
		kn=soft_knobs.sknob[n];
		if(kn.enabled && (special in kn) && kn[special])
			return n;
	}
	return special;
}

/*
** sknobsOnRot
*/
function sknobsOnRot(knob, delta)
{
	var page=page_active;
	var kn, idx;

// check for special cases: knob rotation is bound to jog wheel, up/down or left/right arrows
	if(knob==='jog')
	{
		if('onRotaryJog' in page) {page.onRotaryJog(delta); return;}
		idx=sknobsFindSpecial(knob);
	}
	else if(knob==='updn')
	{
		if('onUpDn' in page) {page.onUpDn(-delta); return;}
		idx=sknobsFindSpecial(knob);
	}
	else if(knob==='ltrt')
	{
		if('onLtRt' in page) {page.onLtRt(delta); return;}
		idx=sknobsFindSpecial(knob);
	}
	else if(knob==='knob')
	{
		if('onKnobRot' in page) page.onKnobRot(delta); // We are not returning here
		idx=sknobsFindSpecial(knob);
	}
	else
		idx=knob;

	if(!(idx in soft_knobs.sknob)) return;
	kn=soft_knobs.sknob[idx];
	if(!kn.enabled) return;

	if(kn.list)
	{
		if(knob==='updn') delta=-delta; // reverse, so that Up moves us up
		kn.list.advance(delta);
		kn.kn.setAngleNrm(sknobsListNrmPos(kn.list));
		return;
	}

	if('onSoftKnobRot' in page) page.onSoftKnobRot(idx+1, delta);
}

/*
** sknobsOnDn
*/
function sknobsOnDn(knob)
{
	var page=page_active;
	var kn, idx;

// check for special cases: knob press is bound to enter
	if(knob==='enter')
		idx=sknobsFindSpecial(knob);
	else
		idx=knob;

	if(!(idx in soft_knobs.sknob))
	{
	// check for unbound special cases
		switch(idx)
		{
		case 'enter':
			if('onEnter' in page) page.onEnter();
			break;
		}
		return;
	}

	kn=soft_knobs.sknob[idx];
	if(!kn.enabled) return;

	if(idx===knob) sknobsSetOne(idx, {down:true});
	if('onSoftKnobDown' in page) page.onSoftKnobDown(idx+1);
}

/*
** sknobsOnUp
*/
function sknobsOnUp(knob)
{
	var page=page_active;
	var kn, idx;

// check for special cases: knob rotation is bound to jog wheel, up/down or left/right arrows
	if(knob==='enter')
		idx=sknobsFindSpecial(knob);
	else if(knob==='chopt')
	{
		if('onChoptUp' in page) {page.onChoptUp(); return;}
		idx=sknobsFindSpecial(knob);
	}
	else
		idx=knob;

	if(!(idx in soft_knobs.sknob))
	{
	// check for unbound special cases
		return;
	}

	kn=soft_knobs.sknob[idx];
	if(!kn.enabled) return;

	if(idx===knob) sknobsSetOne(idx, {down:false});
	if('onSoftKnobUp' in page) page.onSoftKnobUp(idx+1);
}

/*
** sknobsPress
*/
function sknobsPress(knob)
{
	sknobsOnDn(knob);
	sknobsOnUp(knob);
}

/*
** sknobsUpdate
**
** update softknobs rotation angles, using bound list iformation
*/
function sknobsUpdate()
{
	var p, kn;

	for(p in soft_knobs.sknob)
	{
		kn=soft_knobs.sknob[p];
		if(kn.enabled && kn.list)
			kn.kn.setAngleNrm(sknobsListNrmPos(kn.list));
	}
}

/*
** Gui_CreateKnobSection
*/
function Gui_CreateKnobSection(frame)
{
	var n;

	if(cfg_fusionUI)
	{
		soft_knobs.frm3=gui.newFrame(frame, 640/2-(94+2)*3/2, 0, (94+2)*3, 220, '');
		soft_knobs.frm6=gui.newFrame(frame, 640/2-(94+2)*3, 0, (94+2)*6, 220, '');
		soft_knobs.setTitle=function(title){};
	}
	else
	{
	// functions title
		soft_knobs.title_mid   =gui.newLabel(frame, 157, 28, 128, 15, '', style.sknob);
		soft_knobs.title_mid.hide();
		soft_knobs.title_duo=[];
		soft_knobs.title_duo[0]=gui.newLabel(frame,  61, 28, 128, 15, '', style.sknob);
		soft_knobs.title_duo[0].hide();
		soft_knobs.title_duo[1]=gui.newLabel(frame, 253, 28, 128, 15, '', style.sknob);
		soft_knobs.title_duo[1].hide();
		soft_knobs.setTitle=function(title)
		{
			if(typeof(title)=='object' && (0 in title) && (1 in title))
			{
				this.title_mid.hide();

				this.title_duo[0].setText(title[0]);
				this.title_duo[1].setText(title[1]);
				this.title_duo[0].show();
				this.title_duo[1].show();
			}
			else
			{
				this.title_duo[0].hide();
				this.title_duo[1].hide();
				this.title_mid.setText(title);
				this.title_mid.show();
			}
		};

		soft_knobs.frm3=gui.newFrame(frame, 29+3*32, 42, 64*3, 141, '');
		soft_knobs.frm6=gui.newFrame(frame, 29,      42, 64*6, 141, '');
	}

	soft_knobs.frm3.hide(); // frm3 and frm6 are mutually exclusive
	soft_knobs.sknob=[];
	for(n=0; n<9; n++)
	{
		var kn=
		{
			enabled: true,  // is knob enabled
			idx:     0,     // background image index
			list:    null,  // associated list
		// alternative controls
			enter:   false, // allow to control this knob (push) with enter key
			jog:     false, // allow to control this knob with jog wheel
			updn:    false, // allow to control this knob with Up/Down arrows
			ltrt:    false, // allow to control this knob with Left/Right arrows
			knob:    false, // allow to control this knob with Channel Options knob
			chopt:   false  // allow to control this knob (push) with Channel Options button
		};

		if(cfg_fusionUI)
		{
			const lh=30; // line height
			const ylbl=42+lh+42+lh+42+12;  //see kn.bg_bot creating for previous position
			if(n<6)
			{
				kn.fr=gui.newFrame(soft_knobs.frm6, n*(94+2), 0, 94, 220, "");
				kn.lb=gui.newLabel(kn.fr, 0, ylbl, 94, 15, '', style.sknob);
				kn.lb.setText("F"+(n+1));
			}
			else
			{
				kn.fr=gui.newFrame(soft_knobs.frm3, (n-6)*(94+2), 0, 94, 220, "");
				kn.lb=gui.newLabel(kn.fr, 0, ylbl, 94, 15, '', style.sknob);
				kn.lb.setText("F"+(n-5));
			}

			kn.bg_top=gui.newFrame(kn.fr, 94/2-80/2, 0, 80, 42, "img/svg/sknob_label_bg.svg");
			kn.ln_top=gui.newPicture(kn.fr, 94/2-6/2, 42, 6, lh, "img/svg/line_ylw_sknob_bg.svg");
			kn.knbg=gui.newPicture(kn.fr, 94/2-42/2, 42+lh, 42, 42, "img/svg/sknob_ylw.svg");
			kn.kn=gui.newKnob(kn.knbg, 7, 7, 27, 27, "img/svg/sknob_line.svg");
			kn.ln_bot=gui.newPicture(kn.fr, 94/2-6/2, 42+lh+42, 6, lh, "img/svg/line_ylw_sknob_bg.svg");
			kn.bg_bot=gui.newFrame(kn.fr, 94/2-80/2, 42+lh+42+lh, 80, 42, "img/svg/sknob_label_bg.svg");

			kn.rot_icon=gui.newFrame(kn.bg_top, 80/2-18/2, 42/2-18/2, 18, 17, "img/svg/icon_turn.svg");
			kn.rotlb=gui.newLabel(kn.bg_top, 0, 0, 80, 42, '', style.sknoblbl);

			kn.push_icon=gui.newFrame(kn.bg_bot, 80/2-18/2, 42/2-18/2, 18, 18, "img/svg/icon_knob.svg");
			kn.pushlb=gui.newLabel(kn.bg_bot, 0, 0, 80, 42, '', style.sknoblbl);
			kn.setFn=function(fn)
			{
				this.ln_top.setIndex((fn&1)?1:0);
				this.ln_bot.setIndex((fn&2)?1:0);
				if(fn&1)
				{
					this.rot_icon.hide();
					this.rotlb.show();
					this.kn.show();
				}
				else
				{
					this.rotlb.hide();
					this.kn.hide();
					this.rot_icon.show();
				}
				if(fn&2)
				{
					this.push_icon.hide();
					this.pushlb.show();
				}
				else
				{
					this.pushlb.hide();
					this.push_icon.show();
				}
			};
		}
		else
		{
			if(n<6)
			{
				kn.bg=gui.newPicture(soft_knobs.frm6, n*64, 0, 64, 126, "img/sknob_bg.png");
				kn.lb=gui.newLabel(soft_knobs.frm6, n*64, 126, 64, 15, '', style.sknob);
				kn.lb.setText("F"+(n+1));
			}
			else
			{
				kn.bg=gui.newPicture(soft_knobs.frm3, (n-6)*64, 0, 64, 126, "img/sknob_bg.png");
				kn.lb=gui.newLabel(soft_knobs.frm3, (n-6)*64, 126, 64, 15, '', style.sknob);
				kn.lb.setText("F"+(n-5));
			}

		// knob base with shadow
			kn.knbg=gui.newPicture(kn.bg, 7, 37, 51, 51, "img/sknob_blue.png");
			kn.kn=gui.newKnob(kn.knbg, 12, 12, 26, 26, "img/sknob_line.png");
			kn.rotlb =gui.newLabel(kn.bg, 3,  3, 57, 30, '', prop.sknob_blue);
			kn.pushlb=gui.newLabel(kn.bg, 3, 94, 57, 30, '', prop.sknob_blue);

			kn.setFn=function(fn)
			{
				this.bg.setIndex(fn&3);
				if(fn&1)
				{
					this.rotlb.show();
					this.kn.show();
				}
				else
				{
					this.rotlb.hide();
					this.kn.hide();
				}
				if(fn&2)
				{
					this.pushlb.show();
				}
				else
				{
					this.pushlb.hide();
				}
			};
		}
		kn.rotlb.setText('rotate'); // this is for debug only
		kn.pushlb.setText('push');  // this is for debug only
		kn.setFn(0);

	/* add interactive section */
		kn.knbg.id=n;
		kn.knbg.setInput(true);
		kn.knbg.onMouseDown =function(x, y) {sknobsOnDn(this.id);};
		kn.knbg.onMouseUp   =function(x, y) {sknobsOnUp(this.id);};
		kn.knbg.onMouseWheel=function(x, y, delta) {sknobsOnRot(this.id, -delta);};

		soft_knobs.sknob[n]=kn;
	}
}
