// ------------------------ channel aux sends page ------------------------

function chauxPageCreate()
{
	var p;
	var f, aux_fr;
	var n, x;

	p=Page_Create('chaux', 'chn', "");
	f=p.frame;

	if(cfg_fusionUI)
	{
		p.subtitle=GUI_CreatePageSubTitle(f, "AUX SENDS", "img/svg/icon_aux_sends_ylw.svg", 21, 15);
		aux_fr=gui.newFrame(f, 0, 93, 640, 200, "img/svg/ch_edit_aux_bg.svg");

		p.s=[];
		for(n=0; n<4; n++) // FIXME: there is still a bug with 2 colors for inactive
		{
			x=55+n*130;
			p.s[n]=
			{
				onoff: gui.newLabel(aux_fr, x   , 125, 120, 18*3, '', {font:fontSemiBold(9), color:color.lgray, align:gui.CENTER}),
				knob:  gui.newKnob (aux_fr, x+49,  99,  22, 22, "img/svg/knob_22px.svg"),
				val:   gui.newLabel(aux_fr, x+73, 103,  70, 14, '', {font:font.value, color:color.lyellow, align:gui.LEFT}),
				label: gui.newLabel(aux_fr, x+35,  82,  50, 14, "img/svg/send_title_bg.svg", {font:font.value, color:color.lblack, align:gui.CENTER, valign:gui.MIDDLE}),
				v_on: false, v_postfa: false, v_poston: true, v_gain: 0, v_angle: 0,
				tag_on:   host.sprintf("bAUX%d", n+1),
				tag_postfa: host.sprintf("bA%dPF", n+1),
				tag_poston: host.sprintf("bA%dPO", n+1),
				tag_gain: host.sprintf("wA%dGN", n+1),
				name: host.sprintf("SEND %c", 65+n), // 65 is an ASCII code for 'A'
				focus: function(on)
				{
					var pr=on?prop.Focused:prop.Inactive;
					var idx=on?2:0;

					this.onoff.setProps(pr);
					this.val.setProps(pr);
					this.knob.setIndex(idx);
				},
				update: function()
				{
					var val;
					if(this.v_on)
					{
						val="On\n"+(this.v_postfa?"Post Fader":"Pre Fader");
						val+=(this.v_poston?"\nPost On Switch":"\nPre On Switch");
					}
					else
						val="OFF";
					this.onoff.setText(val);
				}
			};
			p.s[n].label.setText(p.s[n].name);
		}
	}
	else
	{
		aux_fr=gui.newFrame(f, 32, 103, 353, 169, "img/ch_edit_aux_bg.png");

		p.s=[];
		for(n=0; n<4; n++)
		{
			x=35+n*70;
			p.s[n]=
			{
				led:   gui.newPicture(aux_fr, x+26,  47, 7, 7, "img/led_7px.png"),
				onoff: gui.newLabel  (aux_fr, x,     55, 60, 14*2, '', prop.value),
				val:   gui.newLabel  (aux_fr, x,     89, 60, 14, '', prop.value),
				knob:  gui.newKnob   (aux_fr, x+19, 106, 22, 22, "img/knob_22px.png"),
				label: gui.newLabel  (aux_fr, x,    132, 60, 14, '', prop.value),
				v_on: false, v_postfa: false, v_poston: true, v_gain: 0, v_angle: 0,
				tag_on:   host.sprintf("bAUX%d", n+1),
				tag_postfa: host.sprintf("bA%dPF", n+1),
				tag_poston: host.sprintf("bA%dPO", n+1),
				tag_gain: host.sprintf("wA%dGN", n+1),
				name: host.sprintf("SEND %c", 65+n), // 65 is an ASCII code for 'A'
				focus: function(on)
				{
					var pr=on?prop.Focused:prop.Inactive;
					var idx=on?2:0;

					this.label.setProps(pr);
					this.onoff.setProps(pr);
					this.val.setProps(pr);
					this.knob.setIndex(idx);
				},
				update: function()
				{
					var val;
					if(this.v_on)
					{
						val="ON "+(this.v_postfa?"POST FA":"PRE FA");
						val+=(this.v_poston?"\nPOST ON":"\nPRE ON");
					}
					else
						val="OFF";
					this.led.setIndex(this.v_on?1:0);
					this.onoff.setText(val);
				}
			};
			p.s[n].label.setText(p.s[n].name);
		}
	}

	p.focus=-1;
	p.setFocus=function(newfocus)
	{
		if(newfocus==this.focus) return;
		if(this.focus in this.s) this.s[this.focus].focus(false);
		this.focus=newfocus;
		if(this.focus in this.s) this.s[this.focus].focus(true);
	}

// softknobs
	p.sknobs6=
	[
		{enabled: true, rot: "SEND A", push: "PRE/POST\nOFF"},
		{enabled: true, rot: "SEND B", push: "PRE/POST\nOFF"},
		{enabled: true, rot: "SEND C", push: "PRE/POST\nOFF"},
		{enabled: true, rot: "SEND D", push: "PRE/POST\nOFF"},
		{enabled: false},
		{enabled: true, push: "EXIT", chopt: true}
	];
	p.sknobs3=
	[
		{enabled: false, rot: "GAIN", push: "PRE/POST\nOFF", enter: true, updn: true, jog: true},
		{enabled: false}, // TODO: Mike's doc shows there should be a preview on Push
		{enabled: true, rot: "SELECT", push: "EXIT", ltrt: true, chopt: true}
	];

// event functions
	p.onOpen =chauxOnOpen;
	p.onClose=chauxOnClose;
	p.onIndi =chauxIndi;
	p.onSoftKnobRot =chauxOnSoftKnobRot;
	p.onSoftKnobDown=chauxOnSoftKnobDown;
	p.onSoftKnobUp  =chauxOnSoftKnobUp;
}
function chauxOnOpen(channel_nr)
{
	if(channel_nr==null) return;
	this.channel=channel_nr;
// Indications
	this.title.setChannel(this.channel);
	mod.setChnKeyLed(this.channel, keys.ChnOptions, 255);
	mod.setChnFusionInvert(this.channel, 1);
	mod.setMasterKeyLed(keys.MstChnAux, 255);
// Register receive msg handlers
	rxHandlersCh[this.channel].chaux=this;

	sknobsShow(mod.comboPresent()?this.sknobs3:this.sknobs6);

	this.setFocus(-1);
	sknobsSetOne(8, {angle: 180});
	sknobsSetOne(6, {angleNrm: 0});

// request aux data
	var rmsg=host.sendChnCmsgRq(this.channel, {id:"READ",
		bAUX1:0, bAUX2:0, bAUX3:0, bAUX4:0,
		bA1PF:0, bA2PF:0, bA3PF:0, bA4PF:0,
		bA1PO:0, bA2PO:0, bA3PO:0, bA4PO:0,
		bA1GN:0, bA2GN:0, bA3GN:0, bA4GN:0
	});
	if(rmsg!=null) this.onIndi(rmsg);
}
function chauxOnClose()
{
	sknobsHide();

// delete receive msg handlers
	delete rxHandlersCh[this.channel].chaux;

	mod.setChnKeyLed(this.channel, keys.ChnOptions, 0);
	mod.setChnFusionInvert(this.channel, 0);
	mod.setMasterKeyLed(keys.MstChnAux, 0);
}
function chauxIndi(chmsg)
{
	var n, snd, update;

	for(n=0; n<4; n++)
	{
		snd=this.s[n];
		update=false;
		if(snd.tag_gain in chmsg)
		{
			snd.v_gain=chmsg[snd.tag_gain];
			snd.v_angle=knobSetValue(snd, snd.v_gain, aux_const);
			sknobsSetOne(n, {angleNrm: snd.v_angle});
			if(this.focus==n)
				sknobsSetOne(6, {angleNrm: snd.v_angle});
		}
		if(snd.tag_on in chmsg)
		{
			snd.v_on=chmsg[snd.tag_on]==1;
			update=true;
		}
		if(snd.tag_postfa in chmsg)
		{
			snd.v_postfa=chmsg[snd.tag_postfa]==1;
			update=true;
		}
		if(snd.tag_poston in chmsg)
		{
			snd.v_poston=chmsg[snd.tag_poston]==1;
			update=true;
		}
		if(update) snd.update();
	}
}
function chauxOnSoftKnobRot(idx, delta)
{
	switch(idx)
	{
	case 1:
		chauxSetGain(this.channel, this.s[0], delta);
		break;
	case 2:
		chauxSetGain(this.channel, this.s[1], delta);
		break;
	case 3:
		chauxSetGain(this.channel, this.s[2], delta);
		break;
	case 4:
		chauxSetGain(this.channel, this.s[3], delta);
		break;
	case 7: // Combo1
		if(this.focus in this.s) chauxSetGain(this.channel, this.s[this.focus], delta);
		break;
	case 9: // Combo3
		this.setFocus(clamp(this.focus+delta, 0, 3));
		sknobsSetOne(8, {angleNrm: this.focus/3});
		var snd=this.s[this.focus];
		sknobsSetOne(6, {enabled: true, rot: snd.name, angleNrm: snd.v_angle});
		break;
	}
}
function chauxOnSoftKnobDown(idx)
{
	switch(idx)
	{
	case 1:
		chauxToggleOn(this.channel, this.s[0]);
		break;
	case 2:
		chauxToggleOn(this.channel, this.s[1]);
		break;
	case 3:
		chauxToggleOn(this.channel, this.s[2]);
		break;
	case 4:
		chauxToggleOn(this.channel, this.s[3]);
		break;
	case 7: // Combo1
		if(this.focus in this.s) chauxToggleOn(this.channel, this.s[this.focus]);
		break;
	}
}
function chauxOnSoftKnobUp(idx)
{
	switch(idx)
	{
	case 6:
	case 9: // Combo3
		chSwitchToPage(this); // will effectively go back to chopt page
		break;
	}
}

function chauxSetGain(chan, send, delta)
{
	var msg={id:'WRIN'};

	if(send.v_gain<=-400)
		delta*=30;
	else if(send.v_gain<=-200)
		delta*=20;
	else if(send.v_gain<=-100)
		delta*=10;
	else if(send.v_gain<= 110)
		delta*=5;

	msg[send.tag_gain]=clamp(send.v_gain+delta, aux_const.min, aux_const.max);
	host.sendChnCmsg(chan, msg);
}

/*
** chauxToggleOn
**
** change aux using following scheme:
** OFF -> ON PRE FA -> ON POST FA -> OFF
**       \-- POST ON -> PRE ON --/
*/
function chauxToggleOn(chan, send)
{
	var msg={id:'WRIN'};

	if(!send.v_on)
	{
	// set ON PRE
		msg[send.tag_on]=1;
		msg[send.tag_postfa]=0;
		msg[send.tag_poston]=1;
	}
	else if(send.v_poston)
	{
		if(!send.v_postfa)
			msg[send.tag_postfa]=1;
		else
		{
			msg[send.tag_postfa]=0;
			msg[send.tag_poston]=0;
		}
	}
	else
	{
		if(!send.v_postfa)
			msg[send.tag_postfa]=1;
		else
		{
			msg[send.tag_on]=0;
			msg[send.tag_poston]=1;
		}
	}
	host.sendChnCmsg(chan, msg);
}
