// ------------------------ channel micproc page ------------------------

function chmicprocCtrlCreate(f, x, y, props)
{
	var obj={};

	if(cfg_fusionUI)
	{
		obj.title=gui.newLabel(f, x, y, 48, 14, '', prop.value);
		obj.title.setText(props.title);
		obj.onoff=gui.newLabel(f, x+65, y, 50, 14, '', {font:font.value, color:color.white, align:gui.CENTER});
		obj.onoff.setText("BYPASS");
	// 2 knobs with labels and values
		obj.thres=knobCreate(f, x-10/2   , y+27, 40+10, "THRES");
		obj.value=knobCreate(f, x+65-10/2, y+27, 40+10, props.value);
	}
	else
	{
		obj.title=gui.newLabel(f, x+ 5, y, 30, 14, '', prop.value);
		obj.title.setText(props.title);
		obj.onoff=gui.newLabel(f, x+40, y, 40, 14, '', prop.value);
		obj.onoff.setText("BYPASS");
	// 2 knobs with labels and values
		obj.thres=knobCreate(f, x   , y+17, 40, "THRES");
		obj.value=knobCreate(f, x+40, y+17, 40, props.value);
	}

	obj.name=props.title;
	obj.valname=props.value;

	obj.v_onoff=0;
	obj.v_thres=0;
	obj.v_value=0;
	obj.a_thres=0;
	obj.a_value=0;

	obj.t_onoff=props.t_onoff;
	obj.t_thres=props.t_thres;
	obj.t_value=props.t_value;
	obj.thres_const=props.thres_const;
	obj.value_const=props.value_const;

	obj.focus=function(on)
	{
		var pr=on?prop.Focused:prop.Inactive;

		this.title.setProps(pr);
		this.onoff.setProps(pr);
		this.thres.focus(on);
		this.value.focus(on);
	};

	obj.thres.val.setText("0 dB");
	obj.value.val.setText("-9 dB");

	return obj;
}

function chmicprocGainCtrlCreate(f, x, y)
{
	var obj={}, knob;
	if(cfg_fusionUI)
	{
		knob=
		{
			lbl:  gui.newLabel(f, x    , y+6, 126, 14, '', prop.value),
			val:  gui.newLabel(f, x+126, y+6,  70, 14, '', prop.value),
			knob: gui.newKnob (f, x+126+70, y, 22, 22, "img/svg/knob_22px.svg")
		};
	}
	else
	{
		knob=
		{
			lbl:  gui.newLabel(f, x    , y+6, 76, 14, '', prop.value),
			val:  gui.newLabel(f, x+80 , y+6, 40, 14, '', prop.value),
			knob: gui.newKnob (f, x+120, y  , 22, 22, "img/knob_22px.png")
		};
	}
	knob.lbl.setText("POST-PROC GAIN");
	knob.focus = function(on)
	{
		var pr=on?prop.Focused:prop.Inactive;

		this.val.setProps(pr);
		this.lbl.setProps(pr);
		this.knob.setIndex(on?2:0);
	};
	obj.value=knob;
	obj.name="POST-PROC";
	obj.valname="GAIN";

	obj.a_value=0;
	obj.v_value=0;
	obj.t_value='wDYTG';
	obj.value_const=mic_range.trim_gain;
	obj.focus=function(on)
	{
		this.value.focus(on);
	};

	return obj;
}

function chmicprocPageCreate()
{
	var p;
	var f, fr;
	var mtrexp, mtrcomp, mtrdess, mtrfrze;

	p=Page_Create('chmicproc', 'chn', "");
	f=p.frame;

	if(cfg_fusionUI)
	{
		p.subtitle=GUI_CreatePageSubTitle(p.frame, "MIC PROCESSING", "img/svg/icon_dynamics_ylw.svg", 25, 13);
		fr=gui.newFrame(p.frame, 0, 93, 640, 250, "img/svg/micproc_bg.svg");

		const x=30;
		const y=70;
		const xd=200;

		p.ctrl=[];
		p.ctrl[0]=chmicprocCtrlCreate(fr, x     , 45+y, {title: "GATE"  , value: "DEPTH", t_onoff: 'bNGAC', t_thres: 'wNGTH', t_value: 'wNGGN', thres_const: mic_range.gate_thres, value_const: mic_range.gate_depth});
		p.ctrl[1]=chmicprocCtrlCreate(fr, x+xd  , 45+y, {title: "COMP"  , value: "RATIO", t_onoff: 'bCOAC', t_thres: 'wCOTH', t_value: 'wCORT', thres_const: mic_range.comp_thres, value_const: mic_range.comp_ratio});
		p.ctrl[2]=chmicprocCtrlCreate(fr, x+xd*2, 45+y, {title: "DE-ESS", value: "RATIO", t_onoff: 'bDEAC', t_thres: 'wDETH', t_value: 'wDERT', thres_const: mic_range.dess_thres, value_const: mic_range.dess_ratio});
		p.ctrl[3]=chmicprocGainCtrlCreate(fr, x+xd+100, y);

	// add meters
		const mx=120; //meter and their labels offset

		f=gui.newFrame(fr, x+mx, 55+y, 28, 60, "img/svg/bar_dyn.svg");
		mtrexp =gui.newMeter(f,  0, 0, 28, 60, "img/svg/bar_dyn_ylw.svg");

		f=gui.newFrame(fr, x+mx+xd, 55+y, 28, 60, "img/svg/bar_dyn.svg");
		mtrcomp=gui.newMeter(f,  0, 0, 28, 60, "img/svg/bar_dyn_ylw.svg");
		mtrfrze=gui.newMeter(fr, x+mx+xd+28/2-16/2, 55+y-16, 16, 16, "img/svg/mtr_freeze.svg");

		f=gui.newFrame(fr, x+mx+xd*2, 55+y, 28, 60, "img/svg/bar_dyn.svg");
		mtrdess=gui.newMeter(f,  0, 0, 28, 60, "img/svg/bar_dyn_ylw.svg");

		mtrexp .setBars(15); mtrexp .setPoints([-300, 15, 0, 0]); mtrexp .setDir(1);
		mtrcomp.setBars(15); mtrcomp.setPoints([-300, 15, 0, 0]); mtrcomp.setDir(1);
		mtrdess.setBars(15); mtrdess.setPoints([-200, 15, 0, 0]); mtrdess.setDir(1);
		mtrfrze.setBars( 1); mtrfrze.setPoints([0, 0, 1, 1]);

		const dy=-1;
		var dyn_bar_def;
		const dyn_bar_def_gate_n_comp={
			"- 0": [0, dy+55+y+1],
			"- 10": [0, dy+55+y+20],
			"- 20": [0, dy+55+y+40],
			"- 30": [0, dy+55+y+60-1]
		};
		const dyn_bar_def_dess={
			"- 0": [0, dy+55+y+1],
			"- 10": [0, dy+55+y+30],
			"- 20": [0, dy+55+y+60-1]
		};

		var i, lbl, mark;
		for(i=0; i<3; i++)
		{
			if(i==2)
				dyn_bar_def=dyn_bar_def_dess;
			else
				dyn_bar_def=dyn_bar_def_gate_n_comp;
			for(mark in dyn_bar_def)
			{
				lbl=gui.newLabel(fr, x+mx+xd*i+30, dyn_bar_def[mark][1]-9, 30, 15, '', {font:fontLight(8), color:color.white, align:gui.LEFT, valign:gui.TOP});
				lbl.setText(mark);
			}
		}
	}
	else
	{
		fr=gui.newFrame(p.frame, 31, 337, 356, 102, "img/micproc_bg.png");

		p.ctrl=[];
		p.ctrl[0]=chmicprocCtrlCreate(fr, 3    , 25, {title: "GATE"  , value: "DEPTH", t_onoff: 'bNGAC', t_thres: 'wNGTH', t_value: 'wNGGN', thres_const: mic_range.gate_thres, value_const: mic_range.gate_depth});
		p.ctrl[1]=chmicprocCtrlCreate(fr, 3+115, 25, {title: "COMP"  , value: "RATIO", t_onoff: 'bCOAC', t_thres: 'wCOTH', t_value: 'wCORT', thres_const: mic_range.comp_thres, value_const: mic_range.comp_ratio});
		p.ctrl[2]=chmicprocCtrlCreate(fr, 3+230, 25, {title: "DE-ESS", value: "RATIO", t_onoff: 'bDEAC', t_thres: 'wDETH', t_value: 'wDERT', thres_const: mic_range.dess_thres, value_const: mic_range.dess_ratio});
		p.ctrl[3]=chmicprocGainCtrlCreate(fr, 190, 3);

	// add meters
		mtrexp =gui.newMeter(fr,  90, 32, 14, 60, "img/mic_meter.png");
		mtrcomp=gui.newMeter(fr, 204, 32, 14, 60, "img/mic_meter.png");
		mtrdess=gui.newMeter(fr, 318, 32, 14, 60, "img/mic_meter.png");
		mtrfrze=gui.newMeter(fr, 206, 20, 11, 11, "img/mtr_freeze.png");
		mtrexp .setBars(30); mtrexp .setPoints([-300, 30, 0, 0]); mtrexp .setDir(1);
		mtrcomp.setBars(30); mtrcomp.setPoints([-300, 30, 0, 0]); mtrcomp.setDir(1);
		mtrdess.setBars(20); mtrdess.setPoints([-200, 20, 0, 0]); mtrdess.setDir(1);
		mtrfrze.setBars( 1); mtrfrze.setPoints([0, 0, 1, 1]);
	}

	gui.createMeter(mtrGUI.ch_mic, 6, null, [mtrexp, mtrcomp, mtrdess, mtrfrze]);

	p.como=false;

	p.focus=-1;
	p.gain_ctrl=false;
	p.setFocus=function(newfocus)
	{
		if(newfocus==this.focus) return;
		if(this.focus in this.ctrl) this.ctrl[this.focus].focus(false);
		this.focus=newfocus;
		if(this.focus in this.ctrl) this.ctrl[this.focus].focus(true);
	}

// softknobs
	p.sknobs6=
	[
		{enabled: true, rot: "GATE\nTHRESH", push: "BYPASS"},
		{enabled: true, rot: "GATE\nDEPTH",  push: "POST-PROC\nGAIN"},
		{enabled: true, rot: "COMP\nTHRESH", push: "BYPASS"},
		{enabled: true, rot: "COMP\nRATIO",  push: "NO FREEZE"},
		{enabled: true, rot: "DE-ESS\nTHRESH", push: "BYPASS"},
		{enabled: true, rot: "DE-ESS\nRATIO",  push: "EXIT", chopt: true}
	];
	p.sknobs3=
	[
		{enabled: false, rot: "THRESH", push: "BYPASS/\nACTIVE", jog: true, enter: true},
		{enabled: false, rot: "DEPTH/\nRATIO", push: "FREEZE/\nNO FREEZE", updn: true},
		{enabled: true,  rot: "FUNCTION", push: "EXIT", ltrt: true, chopt: true}
	];

// event functions
	p.onOpen =chmicprocOnOpen;
	p.onClose=chmicprocOnClose;
	p.onIndi =chmicprocIndi;
	p.onSoftKnobRot =chmicprocOnSoftKnobRot;
	p.onSoftKnobDown=chmicprocOnSoftKnobDown;
	p.onSoftKnobUp  =chmicprocOnSoftKnobUp;
}
function chmicprocOnOpen(channel_nr)
{
	if(channel_nr==null) return;
	this.channel=channel_nr;
// Indications
	this.title.setChannel(this.channel);
	mod.setChnKeyLed(this.channel, keys.ChnOptions, 255);
	mod.setChnFusionInvert(this.channel, 1);
	mod.setMasterKeyLed(keys.MstChnEq, 255);
// Register receive msg handlers
	rxHandlersCh[this.channel].chmicproc=this;

	if(channel_nr==null) return;
	this.channel=channel_nr;
	this.title.setChannel(this.channel);

	sknobsShow(mod.comboPresent()?this.sknobs3:this.sknobs6);

	this.setFocus(-1);
	this.gain_ctrl=false;
	sknobsSetOne(8, {angle: 180});
	sknobsSetOne(6, {angleNrm: 0});
	sknobsSetOne(7, {angleNrm: 0});

// request meters
	chnRequestMeter(this.channel, mtrEng.chnMic, mtrGUI.ch_mic, true);
	var rmsg=host.sendChnCmsgRq(this.channel, {id:"READ",
		bNGAC:0, bCOAC:0, bDEAC:0,
		bNGTH:0, bCOTH:0, bDETH:0,
		bNGGN:0, bCORT:0, bDERT:0,
		bCOMO:0, bDYTG:0
	});
	if(rmsg!=null) this.onIndi(rmsg);
}
function chmicprocOnClose()
{
	sknobsHide();

// release meters
	chnRequestMeter(this.channel, mtrEng.chnMic, mtrGUI.ch_mic, false);
// delete receive msg handlers
	delete rxHandlersCh[this.channel].chmicproc;

	mod.setChnKeyLed(this.channel, keys.ChnOptions, 0);
	mod.setChnFusionInvert(this.channel, 0);
	mod.setMasterKeyLed(keys.MstChnEq, 0);
}
function chmicprocIndi(chmsg)
{
	var n, ctrl, txt;

	for(n in this.ctrl)
	{
		ctrl=this.ctrl[n];
		if(('t_onoff' in ctrl) && (ctrl.t_onoff in chmsg))
		{
			ctrl.v_onoff=(chmsg[ctrl.t_onoff]==1);
			txt=ctrl.v_onoff?"ACTIVE":"BYPASS";
			ctrl.onoff.setText(txt);
			sknobsSetOne(n*2, {push: txt});
			if(this.focus==n)
				sknobsSetOne(6, {push: txt});
		}
		if(('t_thres' in ctrl) && (ctrl.t_thres in chmsg))
		{
			ctrl.v_thres=chmsg[ctrl.t_thres];
			ctrl.a_thres=knobSetValue(ctrl.thres, ctrl.v_thres, ctrl.thres_const);
			sknobsSetOne(n*2, {angleNrm: ctrl.a_thres});
			if(this.focus==n)
				sknobsSetOne(6, {angleNrm: ctrl.a_thres});
		}
		if(('t_value' in ctrl) && (ctrl.t_value in chmsg))
		{
			ctrl.v_value=chmsg[ctrl.t_value];
			ctrl.a_value=knobSetValue(ctrl.value, ctrl.v_value, ctrl.value_const);
			if(this.gain_ctrl && n==3)
				sknobsSetOne(1, {angleNrm: ctrl.a_value});
			else if(n!=3)
				sknobsSetOne(n*2+1, {angleNrm: ctrl.a_value});
			if(this.focus==n)
				sknobsSetOne(7, {angleNrm: ctrl.a_value});
		}
	}

// comp mode
	if('bCOMO' in chmsg)
	{
		this.como=(chmsg.bCOMO==2);
		txt=(this.como?"FREEZE":"NO FREEZE");
		sknobsSetOne(3, {push: txt});
		if(this.focus==1)
			sknobsSetOne(7, {push: txt});
	}
}
function chmicprocOnSoftKnobRot(idx, delta)
{
	var msg={id:'WRIN'};
	var n, ctrl;

	idx--; // fixme

	if(idx==8)
	{
	// change focus
		this.setFocus(clamp(this.focus+delta, 0, 3));
		sknobsSetOne(8, {angleNrm: this.focus/3});
		ctrl=this.ctrl[this.focus];
		if('t_thres' in ctrl)
			sknobsSetOne(6, {enabled: true, rot: ctrl.name+"\nTHRESH", push:ctrl.v_onoff?"ACTIVE":"BYPASS", angleNrm: ctrl.a_thres});
		else
			sknobsSetOne(6, {enabled: false, rot: "THRESH", push: "BYPASS/\nACTIVE", angleNrm:0});
		if('t_value' in ctrl) sknobsSetOne(7, {enabled: true, rot: ctrl.name+"\n"+ctrl.valname, push:this.focus==1?(this.como?"FREEZE":"NO FREEZE"):null, angleNrm: ctrl.a_value});
		return;
	}

	if(idx==1)
		n=(this.gain_ctrl?3:0);
	else if(idx>=0 && idx<=5)
		n=idx>>1;
	else
		n=this.focus;

	if(n in this.ctrl)
	{
		ctrl=this.ctrl[n];

		if(idx&1) // Value
		{
			if(!('t_value' in ctrl)) return;
			msg[ctrl.t_value]=valAdjust(ctrl.v_value, delta, ctrl.value_const);
		}
		else // Thresh
		{
			if(!('t_thres' in ctrl)) return;
			msg[ctrl.t_thres]=valAdjust(ctrl.v_thres, delta, ctrl.thres_const);
		}
		host.sendChnCmsg(this.channel, msg);
	}
}
function chmicprocOnSoftKnobDown(idx)
{
	var msg={id:'WRIN'};
	var n, ctrl;

	if(idx==6 || idx==9) return;
	idx--; // fixme

	if(idx>=0 && idx<=5)
		n=idx>>1;
	else
		n=this.focus;

	if(idx&1)
	{
		if(n==1) // Compressor mode
			host.sendChnCmsg(this.channel, {id:"WRIN", bCOMO: (this.como?1:2)});
	}
	else
	{
		if(n in this.ctrl)
		{
			ctrl=this.ctrl[n];
			if(!('t_onoff' in ctrl)) return;
			msg[ctrl.t_onoff]=ctrl.v_onoff?0:1;
			host.sendChnCmsg(this.channel, msg);
		}
	}
}
function chmicprocOnSoftKnobUp(idx)
{
	switch(idx)
	{
	case 2:
		if(this.gain_ctrl)
		{
			this.gain_ctrl=false;
			sknobsSetOne(1, {rot:"GATE\nDEPTH", push:"POST-PROC\nGAIN", angleNrm:this.ctrl[0].a_value});
		}
		else
		{
			this.gain_ctrl=true;
			sknobsSetOne(1, {rot:"POST-PROC\nGAIN", push:"GATE\nDEPTH", angleNrm:this.ctrl[3].a_value});
		}
		break;
	case 6:
	case 9: // Combo3
		chSwitchToPage(this); // will effectively go back to chopt page
		break;
	}
}
