// ------------------------ channel option page ------------------------
function chsrcPageCreate()
{
	var p;
	var f, list_fr;

	p=Page_Create('chsrc', 'chn', "");
	f=p.frame;
// ch.options container frame
	if(cfg_fusionUI)
	{
		list_fr=gui.newFrame(f, 0, 40+3, 640, 504, "img/svg/ch_edit_src_bg.svg");
		gui.newFrame(list_fr, 640-20-20, 12, 20, 12, "img/svg/icon_source_list.svg");
		//we do not need to refer to these labels later on
		list_fr.srclabel=gui.newLabel(list_fr, 12, 12, 135, 16, '', {font:fontSemiBold(9), color:color.lgray, align:gui.RIGHT, valign:gui.MIDDLE});
		list_fr.srclabel.setText("CURRENT SOURCE:");
		list_fr.typelabel=gui.newLabel(list_fr, 12, 12+16+2, 135, 16, '', {font:fontSemiBold(9), color:color.lgray, align:gui.RIGHT, valign:gui.MIDDLE});
		list_fr.typelabel.setText("TYPE:");

		p.cursrc_name=gui.newLabel(list_fr, 12+135+3, 12, 150, 16, '', {font:fontSemiBold(9), color:color.lyellow, align:gui.LEFT, valign:gui.MIDDLE});
		p.cursrc_type=gui.newLabel(list_fr, 12+135+3, 12+16+2, 80, 16, '', {font:fontSemiBold(9), color:color.lyellow, align:gui.LEFT, valign:gui.MIDDLE});

		p.list=gui.newList(list_fr, 10, 85, 625, 410, '', prop.list);
		p.list.setColumns([160, 145, 140, -1, 0]);
		GUI_createSmallMeter(list_fr, 620/2-540/2+10+541, 60-24/2, mtrGUI.ch_src);
	}
	else
	{
		list_fr=gui.newFrame(f, 32, 103, 353, 329, "img/ch_edit_src_bg.png");
		p.cursrc_type=gui.newLabel(list_fr, 125, 14,  50, 14, '', prop.value);
		p.cursrc_name=gui.newLabel(list_fr, 180, 10, 160, 19, '', prop.src);
		p.list=gui.newList(list_fr, 10, 65, 330, 240, '', prop.list);
		p.list.setColumns([72, 55, 80, -1, 90]);

		GUI_createSmallMeter(list_fr, 329, 39, mtrGUI.ch_src);
	}

// softknobs
	p.sknobs6=
	[
		{enabled: true,  rot: "SOURCE", push: "TAKE", list: p.list, updn: true, jog: true, enter: true, knob: true},
		{enabled: false, push: "PREVIOUS"},
		{enabled: true,  push: "PREVIEW"},
		{enabled: false},
		{enabled: false},
		{enabled: true, push: "EXIT"}
	];
	p.sknobs3=
	[
		{enabled: true, rot: "SELECT", push: "TAKE", list: p.list, updn: true, jog: true, enter: true, knob: true},
		{enabled: true, push: "PREVIEW"},
		{enabled: true, push: "EXIT"}
	];

// locals
	p.srci=null;
	p.prev=null;
	p.knobUsed=false;
// event functions
	p.onOpen =chsrcOnOpen;
	p.onClose=chsrcOnClose;
	p.onIndi =chsrcIndi;
	p.onSrcLstUpdate=chsrcReload;
	p.onSoftKnobRot =chsrcOnSoftKnobRot;
	p.onSoftKnobDown=chsrcOnSoftKnobDown;
	p.onSoftKnobUp  =chsrcOnSoftKnobUp;

	p.onKnobRot     =function(){this.knobUsed=true;};
	p.onChoptUp     =function(){this.onSoftKnobUp(this.knobUsed?1:6); if(this.knobUsed) closePage(this, this.channel);}
// other functions
	p.chsrcIndi     =chsrcIndi;
	p.chsrcIndiList =chsrcIndiList;
	p.chsrcSelectSrc=chsrcSelectSrc;
}
function chsrcOnOpen(channel_nr)
{
	if(channel_nr==null) return;
	this.channel=channel_nr;
// Indications
	this.title.setChannel(this.channel);
	mod.setChnKeyLed(this.channel, keys.ChnOptions, 255);
	mod.setChnFusionInvert(this.channel, 1);
	mod.setMasterKeyLed(keys.MstChnSrc, 255);
// Register receive msg handlers
	rxHandlersCh[this.channel].chsrc=this;

	sknobsShow(mod.comboPresent()?this.sknobs3:this.sknobs6);

	this.srci=null;
	this.prev=null;
	this.knobUsed=false;

// request meters
	chnRequestMeter(this.channel, mtrEng.chnSrc, mtrGUI.ch_src, true);
// request current source for this channel
	var rmsg=host.sendChnCmsgRq(this.channel, {id:"READ", bSRCI:0, bSRCN:0, bSRCT:0});
	if(rmsg!=null) this.chsrcIndi(rmsg);
// request source list
	rmsg=getSourceList(this.channel, true);
	if(rmsg!=null) this.chsrcIndiList(rmsg);
}
function chsrcOnClose()
{
	sknobsHide();

// release meters
	chnRequestMeter(this.channel, mtrEng.chnSrc, mtrGUI.ch_src, false);
// delete receive msg handlers
	delete rxHandlersCh[this.channel].chsrc;

	mod.setChnKeyLed(this.channel, keys.ChnOptions, 0);
	mod.setChnFusionInvert(this.channel, 0);
	mod.setMasterKeyLed(keys.MstChnSrc, 0);
}
function chsrcIndi(chmsg)
{
	if('bvSRCN' in chmsg) this.cursrc_name.setText(host.arrtostr(chmsg.bvSRCN));
	if( 'bSRCT' in chmsg) this.cursrc_type.setText(srct_txt[chmsg.bSRCT]);
	if( 'dSRCI' in chmsg)
	{
		this.prev=this.srci;
		this.srci=chmsg.dSRCI;
		setListActive(this.list, this.srci=chmsg.dSRCI);
		if(this.prev!=null)
			sknobsSetOne(1, {enabled:true});
	}
}
function chsrcIndiList(msg)
{
	var n, tag, src, id, row, icon;

	if(!('wSRLC' in msg)) {log.warning("malformed source list received"); return;}

	this.list.hide();
	this.list.clear();

	if(this.srci==src_NONE_id)
		this.list.insert("NONE", src_NONE_id, 1, 1);
	else
		this.list.insert("NONE", src_NONE_id, 0, 0);

	if('mSRLE' in msg)
	{
		for(n=1; n<=msg.wSRLC; n++)
		{
			tag=host.sprintf("m%04d", n);
			if(!(tag in msg.mSRLE)) continue;

			src=msg.mSRLE[tag];
			if(!('dSRCI' in src) || !('sSRCN' in src) || !('bSRCT' in src)
			|| !('sPSNM' in src) || !('bBUSY' in src) || !('bCTRL' in src)) continue;

			id=src.dSRCI;
			if(src.bCTRL)
				icon=src.bBUSY?4:3; // 'x' when busy, '*' when available
			else
				icon=2; // speaker - listen only
			//  name             type                       PSC name         icon
			row=src.sSRCN+lstSep+srct_txt[src.bSRCT&127]+lstSep+src.sPSNM+lstSep+icon;
			if(src.bBUSY && ('sSCON' in src) && ('bSCFN' in src))
				row+=lstSep+src.bSCFN+": "+src.sSCON;
			if(this.srci==id)
				this.list.insert(row, id, 1, 1);
			else
				this.list.insert(row, id, 0, 0);
		}
	}
	this.list.select(0);
	this.list.show();

	sknobsUpdate();
}
function chsrcOnSoftKnobRot(idx, delta)
{
	if(idx==1 || idx==7)
	{
	// scroll PM's sources list: FIXME: this is broken!
		prodSrcSelect(this.list.selection-prod_src_nr_scr);
		prod_src_sync=true;
	}
}
function chsrcOnSoftKnobDown(idx)
{
	switch(idx)
	{
	case 3: // preview
	case 8:
		host.sendNestCmsg('mPREV', {id:"WRIN", dSRCI:this.list.selId});
		break;
	}
}
function chsrcOnSoftKnobUp(idx)
{
	switch(idx)
	{
	case 1: // select
	case 7:
		this.chsrcSelectSrc(this.list.selId);
		break;
	case 2: // previous
		if(this.prev!=null) this.chsrcSelectSrc(this.prev);
		break;
	case 3: // preview
	case 8:
		host.sendNestCmsg('mPREV', {id:"WRIN", dSRCI:src_NONE_id});
		break;
	case 6:
	case 9: // Combo3
		chSwitchToPage(this); // will effectively go back to chopt page
		break;
	}
}
function chsrcSelectSrc(src_id)
{
	host.sendChnCmsg(this.channel, {id:"WRIN", dSRCI:src_id});
}

function chsrcReload(mask)
{
	if(mask[this.channel]==0) return;
	var selId=this.list.selId;
	var rmsg=getSourceList(this.channel, true);
	if(rmsg!=null)
	{
		this.chsrcIndiList(rmsg);
		setListSelection(this.list, selId);
		sknobsUpdate();
	}
}
