// ------------------------- * network setup * -------------------------
const netSetupTitles=
[
	'IP ADDRESS',
	'SUBNET MASK',
	'GATEWAY IP ADDRESS',
	'NTP SERVER IP ADDRESS',
	'ENGINE IP ADDRESS',
	'WEB PAGE USER PASSWORD'
];
const ipActions=
[
	"SAVE",
	"UNDO",
	"REBOOT"
];
const have_engine_ip=true;
const ipLastItemIdx=netSetupTitles.length-1;
const ipActionToKnob=[5,3,4];

function dasmIP(ip)
{
	return [ip&0xFF, (ip>> 8)&0xFF, (ip>>16)&0xFF, (ip>>24)&0xFF];
}
function str2daIP(str)
{
	var a, n, res=[];
	a=str.split('.')
	if(a.length!=4) return false;
	for(n=0; n<4; n++)
	{
		if(a[n].length<1 || a[n].length>3) return [0,0,0,0];
		res[n]=parseInt(a[n]);
		if(res[n]<0 || res[n]>255) return [0,0,0,0];
	}
	return res;
}

function asmIP(ip)
{
	return ip[0]|(ip[1]<<8)|(ip[2]<<16)|(ip[3]<<24);
}
function daIP2str(ip)
{
	return ip[0]+'.'+ip[1]+'.'+ip[2]+'.'+ip[3];
}
function isValueZero(v)
{
	return (v[0]==0 && v[1]==0 && v[2]==0 && v[3]==0);
}

function ipPageCreateItem(f, x, y, ip)
{
	var n;
	var item={};

	item.ip=[];
	item.value=[];
	if(cfg_fusionUI)
	{
		item.label=gui.newLabel(f, x, y, 220, 20, '', {font:font.value, color:gui.rgb(111,111,111), align:gui.LEFT, valign:gui.MIDDLE});
		if(ip)
		{
			for(n=0; n<4; n++)
				item.ip[n]=gui.newLabel(f, x+220+22+52*n, y, 38, 20, '', {font:font.value, color:gui.rgb(111,111,111), align:gui.CENTER, valign:gui.MIDDLE, border:1, bordercolor:gui.rgb(111,111,111)});
		}
		else
		{
			for(n=0; n<4; n++)
				item.ip[n]=gui.newLabel(f, x+x+220+22+24*n, y, 24, 20, '', {font:font.value, color:gui.rgb(111,111,111), align:gui.CENTER, valign:gui.MIDDLE, border:1, bordercolor:gui.rgb(111,111,111)});
		}
		item.focus=function(on)
		{
			var n;
			this.label.setProp('color', on?color.lyellow:gui.rgb(111,111,111));
			for(n=0; n<4; n++) this.ip[n].setProps(on?{color:color.lyellow, bgcolor:color.black, bordercolor:color.lyellow}:{color:gui.rgb(111,111,111), bgcolor:0, bordercolor:gui.rgb(111,111,111)});
		};
		item.setPos=function(pos)
		{
			var n;
			for(n=0; n<4; n++) this.ip[n].setProps((n==pos)?{color:color.black, bgcolor:color.lyellow}:{color:color.lyellow, bgcolor:color.black});
		};
	}
	else
	{
		item.label=gui.newLabel(f, x, y, 140, 14, '', prop.value_left);
		if(ip)
		{
			item.boxbg=["img/ip_box.png", "img/ip_boxs.png"];
			item.box=gui.newFrame(f, x+140, y, 146, 15, item.boxbg[0]);
			for(n=0; n<4; n++)
			{
				item.ip[n]=gui.newLabel(item.box, 1+39*n, 1, 27, 13, '', prop.value);
				item.ip[n].setProps({bgcolor:color.dblue});
			}
		}
		else
		{
			item.boxbg=["img/pass_box.png", "img/pass_boxs.png"];
			item.box=gui.newFrame(f, x+140, y, 63, 15, item.boxbg[0]);
			for(n=0; n<4; n++)
			{
				item.ip[n]=gui.newLabel(item.box, 1+16*n, 1, 13, 13, '', prop.value);
				item.ip[n].setProps({bgcolor:color.dblue});
			}
		}
		item.focus=function(on)
		{
			var n;
			this.label.setProp('color', on?color.yellow:color.ltblue);
			this.box.setBg(this.boxbg[on?1:0]);
			for(n=0; n<4; n++) this.ip[n].setProps(on?{color:color.yellow, bgcolor:color.dblue}:{color:color.ltblue, bgcolor:color.dblue});
		};
		item.setPos=function(pos)
		{
			var n;
			for(n=0; n<4; n++) this.ip[n].setProps((n==pos)?{color:color.dblue, bgcolor:color.yellow}:{color:color.yellow, bgcolor:color.dblue});
		};
	}
	item.setValue=function()
	{
		var n;
		for(n=0; n<4; n++) this.ip[n].setText(host.sprintf("%3d", this.value[n]));
	};
	return item;
}

function ipPageCreate()
{
	var p, fr;
	var n, m;

	p=Page_Create('ip', 'glob', "NET OPTIONS");
// ip configuration menu
	if(cfg_fusionUI)
	{
		fr=gui.newFrame(p.frame, 0, 40+7, 640, 500, "img/svg/ip_bg.svg");
		fr.caption=gui.newLabel(fr,  12+3, 12, 250, 16, '', {font:font.value, color:color.lyellow, align:gui.LEFT});
		fr.caption.setText("SET IP ADDRESS");
	}
	else
		fr=gui.newFrame(p.frame, 32, 103, 353, 329, "img/mst_ip_bg.png");

	p.item=[];
	p.curItem=-1;
	p.curPos=-1;
	p.numeric=false;

	for(n=0; n<=ipLastItemIdx; n++)
	{
		if(cfg_fusionUI)
			p.item[n]=ipPageCreateItem(fr, 30, 60+10+40*n, (n<ipLastItemIdx));
		else
			p.item[n]=ipPageCreateItem(fr, 30, 79+30*n, (n<ipLastItemIdx));
	}
// softknobs
	p.sknobs6=
	[
		{enabled: true, rot: "SELECT", push: "TAKE", jog: true, enter: true},
		{enabled: false},
		{enabled: true, push: "UNDO"},
		{enabled: true, push: "REBOOT"},
		{enabled: true, push: "SAVE"},
		{enabled: true, push: "EXIT"}
	];
	p.sknobs3=
	[
		{enabled: true, rot: "SELECT", push: "TAKE", jog: true, enter: true},
		{enabled: true, rot: "ACTION", push: "SAVE"},
		{enabled: true, push: "EXIT"}
	];
	p.action=0;

// Helper Functions
	p.readNetConfig=function()
	{
		var netconf=host.getNetSetup();
		var n;

		this.item[0].value=dasmIP(netconf.ipaddr);
		this.item[1].value=dasmIP(netconf.netmask);
		this.item[2].value=dasmIP(netconf.gateway);
		this.item[3].value=str2daIP(host.cfgGetString("ntp.address", "0.0.0.0"));
		if(have_engine_ip)
		{
		// read from ACL
			var rmsg=host.sendNestCmsgRq('mCONF', {id:"READ", bENGA:0});
			if(rmsg!=null && ('dENGA' in rmsg))
				this.item[4].value=dasmIP(rmsg.dENGA);
			else
				this.item[4].value=[0,0,0,0];
		}

		this.item[ipLastItemIdx].value=[0,0,0,0];
		for(n=0; n<4; n++)
			this.item[ipLastItemIdx].ip[n].setText(this.curItem==ipLastItemIdx?"0":"");
		for(n=0; n<=ipLastItemIdx; n++)
		{
			if(n<ipLastItemIdx) this.item[n].setValue();
			this.item[n].label.setText(netSetupTitles[n]);
		}
	};
	p.writeNetConfig=function()
	{
		var netconf={};

		netconf.ipaddr =asmIP(this.item[0].value);
		netconf.netmask=asmIP(this.item[1].value);
		netconf.gateway=asmIP(this.item[2].value);
		host.setNetSetup(netconf);
	// ntp ip
		host.cfgSetString("ntp.address", daIP2str(this.item[3].value));
		if(have_engine_ip) host.sendNestCmsg('mCONF', {id:"WRNI", dENGA:asmIP(this.item[4].value)});

		var new_pass="";
		var new_pass_set=false;
		var m;
		for(m=0; m<4; m++)
		{
			if(this.item[ipLastItemIdx].value[m]!=0) new_pass_set=true;
			new_pass+=host.sprintf("%1d", this.item[ipLastItemIdx].value[m]);
		}
		if(new_pass_set) /* change HTTP access password */
			host.httpSetPassword(new_pass);
	};
	p.selectItem=function(index)
	{
		var n;
		var ci;

		if(this.curItem==index) return;

	// deselect previous
		if(this.curItem>=0 && this.curItem<=ipLastItemIdx)
		{
			ci=this.item[this.curItem];
			ci.focus(false);
			if(this.curItem==ipLastItemIdx && isValueZero(ci.value))
				for(n=0; n<4; n++)
					ci.ip[n].setText("");
		}

	// select next
		if(index>=0 && index<=ipLastItemIdx)
		{
			ci=this.item[index];
			ci.focus(true);
			if(index==ipLastItemIdx && isValueZero(ci.value))
				for(n=0; n<4; n++)
					ci.ip[n].setText("0");
		}
		this.curItem=index;
		sknobsSetOne(0, {angleNrm: this.curItem/ipLastItemIdx});
		sknobsSetOne(6, {angleNrm: this.curItem/ipLastItemIdx});
	};
	p.selectPos=function(index)
	{
		if(this.curPos==index) return;

		this.item[this.curItem].setPos(index);

		this.numeric=false;
		this.curPos=index;
	};
	p.incIP=function(step)
	{
		var val;
		var ci=this.item[this.curItem];

		this.numeric=false;
		val=ci.value[this.curPos]+step;
		if(this.curItem<ipLastItemIdx)
		{
			if(val>=0 && val<=255)
			{
				ci.value[this.curPos]=val;
				ci.ip[this.curPos].setText(host.sprintf("%3d", val));
				ci.label.setText(netSetupTitles[this.curItem]+' *');
			}
		}
		else
		{
			if(val>=0 && val<=9)
			{
				ci.value[this.curPos]=val;
				ci.ip[this.curPos].setText(host.sprintf("%d", val));
				if(isValueZero(ci.value))
					ci.label.setText(netSetupTitles[this.curItem]);
				else
					ci.label.setText(netSetupTitles[this.curItem]+' *');
			}
		}
	};
	p.numIP=function(num)
	{
		var val;
		var ci=this.item[this.curItem];

		if(!this.numeric)
		{
			val=num;
			this.numeric=true;
		}
		else
		{
			if(num==10) //delete last digit
				val=Math.floor(ci.value[this.curPos]/10);
			else
				val=ci.value[this.curPos]*10+num;
		}

		if(this.curItem<ipLastItemIdx)
		{
			if(val>=0 && val<=255)
			{
				ci.value[this.curPos]=val;
				ci.ip[this.curPos].setText(host.sprintf("%3d", val));
				ci.label.setText(netSetupTitles[this.curItem]+' *');
			}
		}
		else
		{
			if(val>=0 && val<=9)
			{
				ci.value[this.curPos]=val;
				ci.ip[this.curPos].setText(host.sprintf("%3d", val));
				if(isValueZero(ci.value))
					ci.label.setText(netSetupTitles[this.curItem]);
				else
					ci.label.setText(netSetupTitles[this.curItem]+' *');
			}
		}
	};

	p.onOpen=function(channel_nr)
	{
		sknobsShow(mod.comboPresent()?this.sknobs3:this.sknobs6);
		sknobsSetOne(0, {angleNrm: this.curItem/ipLastItemIdx});
		sknobsSetOne(6, {angleNrm: this.curItem/ipLastItemIdx});
		sknobsSetOne(7, {angleNrm: 0});
		this.action=0;

		this.readNetConfig();
		this.selectItem(0);
		this.selectPos(-1);
	};
	p.onClose=function()
	{
		sknobsHide();
	};
	p.onNumpadDown=function(key)
	{
		if(this.curPos!=-1)
		{
			if(key>=0 && key<=10) // 10=='*': delete last digit
				this.numIP(key);
			else if(key==11) // 11=='#': go right
				this.onLtRt(1);
		}
	};
	p.onUpDn=function(delta)
	{
		if(delta<0)
		{
			if(this.curPos==-1)
			{
				if(this.curItem>0) this.selectItem(this.curItem-1);
			}
			else
				this.incIP(1);
		}
		else if(delta>0)
		{
			if(this.curPos==-1)
			{
				if(this.curItem<ipLastItemIdx) this.selectItem(this.curItem+1);
			}
			else
				this.incIP(-1);
		}
	};
	p.onLtRt=function(delta)
	{
		if(delta<0 && this.curPos>=0)
			this.selectPos(this.curPos-1);
		else if(delta>0 && this.curPos<=3)
			this.selectPos(this.curPos==3?-1:this.curPos+1);
	};
	p.onSoftKnobDown=function(idx)
	{
		if(idx==8)
			idx=ipActionToKnob[this.action];
		switch(idx)
		{
		case 1:
		case 7:
			this.onLtRt(1);
			break;
		case 3:
			this.readNetConfig();
			this.selectItem(0);
			this.selectPos(-1);
			break;
		case 4:
		// reboot
			host.reboot();
			break;
		case 5:
		// save
			this.writeNetConfig();
			this.readNetConfig();
			break;
		}
	};
	p.onSoftKnobUp=function(idx)
	{
		switch(idx)
		{
		case 6:
		case 9:
			closePage(this, null);
			break;
		}
	};
	p.onSoftKnobRot=function(idx, delta)
	{
		var aname;

		switch(idx)
		{
		case 1:
		case 7:
			if(this.curPos==-1)
			{
				if(delta<0 && this.curItem>0)
					this.selectItem(this.curItem-1);
				else if(delta>0 && this.curItem<ipLastItemIdx)
					this.selectItem(this.curItem+1);
			}
			else
				this.incIP(delta<0?-1:1);
			break;
		case 8:
			this.action=clamp(this.action+delta, 0, 2);
			aname=ipActions[this.action];
			sknobsSetOne(7, {angleNrm:this.action/2, push: aname});
			break;
		}
	};
}
