// ------------------------ global returns page ------------------------

function returnsCreateObject(frame, x, y, title, tag)
{
	var obj={};

	if(cfg_fusionUI)
	{
		obj.on   =gui.newLabel(frame, x+21-10/2, y   , 20+10, 20, "", prop.value);
		obj.knob =gui.newKnob (frame, x+20, y+40, 22, 22, "img/svg/knob_22px.svg");
		obj.val  =gui.newLabel(frame, x-10/2   , y+25, 60+10, 14, '', prop.value);
		obj.label=gui.newLabel(frame, x, y+67, 70, 14, '', {font:fontSemiBold(10), color:color.lyellow, align:gui.CENTER, valign:gui.MIDDLE});
		obj.assgn=gui.newLabel(frame, x+67+20, y+67+10, 60, 14, '', prop.value);
		obj.pgmlst=gui.newList(frame, x+67+20, y   , 60, 74, '', prop.list);
		obj.pgmlst.setProps({font:fontSemiBold(9)});
		obj.setOn=function(on) {this.on.setText(on?"ON":"OFF");};
	}
	else
	{
		obj.on   =gui.newPicture(frame, x+21, y   , 20, 20, "img/on_off.png");
		obj.knob =gui.newKnob   (frame, x+20, y+40, 22, 22, "img/knob_22px.png");
		obj.val  =gui.newLabel  (frame, x   , y+25, 60, 14, '', prop.value);
		obj.label=gui.newLabel  (frame, x+ 2, y+63, 60, 14, '', prop.value);
		obj.assgn=gui.newLabel  (frame, x+67, y+63, 60, 14, '', prop.value);
		obj.pgmlst=gui.newList  (frame, x+67, y   , 50, 60, '', prop.list);
		obj.setOn=function(on) {this.on.setIndex(on?1:0);};
	}
	obj.label.setText(title);
	obj.assgn.setText("ASSIGN");
	obj.pgmlst.insert("PGM1", 0);
	obj.pgmlst.insert("PGM2", 1);
	obj.pgmlst.insert("PGM3", 2);
	obj.pgmlst.insert("PGM4", 3);
	obj.pgmlst.selection=0;

	obj.tag=tag;
	obj.preview=false;
	obj.onsw=false;
	obj.msgn=0;
	obj.pgm=[0,0,0,0];

	return obj;
}

function returnsPageCreate()
{
	var p;
	var aux_fr;

	p=Page_Create('returns', 'mon', "RETURNS");

	if(cfg_fusionUI)
	{
		aux_fr=gui.newFrame(p.frame, 0, 6+27+10, 640, 240, "img/svg/aux_sends_bg_lrg.svg");
		aux_fr.title=gui.newLabel(aux_fr, 10, 10, 228, 16, '', prop.value_left_medium);
		aux_fr.title.setText("AUX RETURNS");
		gui.newFrame(aux_fr, 640-10-21, 12, 21, 15, "img/svg/icon_aux_returns.svg");

		const x=125;
		const dx=225;
		const y=20;

		p.returns=[];
		p.returns[0]=returnsCreateObject(aux_fr,  x, 37+y, "RETURN A", 'mRET1');
		p.returns[1]=returnsCreateObject(aux_fr, x+dx, 37+y, "RETURN B", 'mRET2');

	// indicates which channel will be controlled with preview knob
		p.preview=gui.newFrame(aux_fr, 110, 118+y+3, 90, 39, '');
		p.preview.line =gui.newPicture(p.preview, 90/2-1,  0,  2, 22, "img/svg/line_vert_22px.svg");
		p.preview.label=gui.newLabel  (p.preview,  0, 24, 90, 14, '', prop.value);
		p.updatePreview=function()
		{
			this.preview.moveTo(110+this.prv_select*225, 141);
			this.preview.label.setText(this.returns[this.prv_select].preview?"PREVIEW ON":"PREVIEW OFF");
		};
	}
	else
	{
		aux_fr=gui.newFrame(p.frame, 32, 270, 353, 169, "img/mst_returns_bg.png");

		p.returns=[];
		p.returns[0]=returnsCreateObject(aux_fr,  13, 37, "RETURN A", 'mRET1');
		p.returns[1]=returnsCreateObject(aux_fr, 163, 37, "RETURN B", 'mRET2');

	// indicates which channel will be controlled with preview knob
		p.preview=gui.newFrame(aux_fr, 15, 118, 60, 39, '');
		p.preview.line =gui.newPicture(p.preview, 29,  0,  2, 22, "img/line_vert.png");
		p.preview.label=gui.newLabel  (p.preview,  0, 24, 60, 14, '', prop.value);
		p.updatePreview=function()
		{
			const xpos=[15,165];

			this.preview.moveTo(xpos[this.prv_select], 118);
			this.preview.label.setText(this.returns[this.prv_select].preview?"PREVIEW ON":"PREVIEW OFF");
		};
	}
	p.prv_select=0;
	p.updatePreview();

	p.sknobs6=
	[
		{enabled: true, rot: "RETURN A", push: "OFF"},
		{enabled: true, rot: "ASSIGN",   push: "TAKE", list:p.returns[0].pgmlst},
		{enabled: true, rot: "RETURN B", push: "OFF"},
		{enabled: true, rot: "ASSIGN",   push: "TAKE", list:p.returns[1].pgmlst},
		{enabled: false},
		{enabled: true, rot: "SELECT",   push: "PREVIEW"}
	];

// event handling functions
	p.onOpen=function(channel_nr)
	{
		var rmsg, read_msg={id:"READ", bMSGN:0, bONSW:0, bPREV:0, bPGM1:0, bPGM2:0, bPGM3:0, bPGM4:0};

	// Indications
		mod.setMasterKeyLed(keys.MstSendRet, 255);

		sknobsShow(this.sknobs6);

	// register receive msg handlers
		rxHandlersGlobal.returnsIndi=returnsIndi;

		rmsg=host.sendCmsgRq({id:"NEST", mRET1:read_msg, mRET2:read_msg});
		if(rmsg!=null) returnsIndi(rmsg);
	}
	p.onClose=function()
	{
	// turn preview off if it is ON
		if(this.returns[this.prv_select].preview) host.sendNestCmsg(this.returns[this.prv_select].tag, {id:'WRIN', bPREV:0});
		sknobsHide();
	// delete receive msg handlers
		delete rxHandlersGlobal.returnsIndi;
		mod.setMasterKeyLed(keys.MstSendRet, 0);
	}
	p.onSoftKnobRot=function(idx, delta)
	{
		switch(idx)
		{
		case 1:
			sendsSetGain("mRET1", this.returns[0].msgn, delta)
			break;
		case 3:
			sendsSetGain("mRET2", this.returns[1].msgn, delta)
			break;
		case 6:
			if(delta==0) break;
			if(this.returns[this.prv_select].preview) break; // Preview is on, don't allow to navigate from it
			this.prv_select=clamp(this.prv_select+(delta>0?1:-1), 0, 1);
			this.updatePreview();
			sknobsSetOne(5, {angleNrm:p.prv_select});
			break;
		}
	}
	p.onSoftKnobDown=function(idx)
	{
		var ind;

		switch(idx)
		{
		case 1:
		case 3:
			idx=(idx-1)/2;
			toggleVal(this.returns[idx].tag, 'bONSW', this.returns[idx].onsw);
			break;
		case 2:
		case 4:
			idx=(idx-2)/2;
			ind=this.returns[idx].pgmlst.selId;
			toggleVal(this.returns[idx].tag, "bPGM"+(ind+1), this.returns[idx].pgm[ind]);
			break;
		case 6:
			host.sendNestCmsg(this.returns[this.prv_select].tag, {id:'WRIN', bPREV:1});
			break;
		}
	}
	p.onSoftKnobUp=function(idx)
	{
		switch(idx)
		{
		case 6:
			host.sendNestCmsg(this.returns[this.prv_select].tag, {id:'WRIN', bPREV:0});
			break;
		}
	}
}
function returnsIndi(msg)
{
	var p=pages.returns;
	var n, obj;

	for(n=0; n<2; n++)
	{
		obj=p.returns[n];
		if(obj.tag in msg)
			returnsIndiEx(msg[obj.tag], p, obj, n*2);
	}
}
function returnsSetAssignment(bus_obj, pgm_idx, pgm_val)
{
		bus_obj.pgm[pgm_idx]=pgm_val;
		bus_obj.pgmlst.goPos(pgm_idx);
		bus_obj.pgmlst.icon =pgm_val;
		bus_obj.pgmlst.flags=pgm_val;
}
function returnsIndiEx(submsg, page, bus_obj, soft_knob_idx)
{
	var angl;

	if('wMSGN' in submsg)
	{
		bus_obj.msgn=submsg.wMSGN;
		angl=knobSetValue(bus_obj, bus_obj.msgn, aux_const);
		sknobsSetOne(soft_knob_idx, {angleNrm: angl});
	}
	if('bONSW' in submsg)
	{
		bus_obj.onsw=submsg.bONSW!=0;
		bus_obj.setOn(bus_obj.onsw);
		sknobsSetOne(soft_knob_idx, {push: bus_obj.onsw?"ON":"OFF"});
	}
	if('bPREV' in submsg)
	{
		bus_obj.preview=submsg.bPREV!=0;
		page.updatePreview();
	}
	if('bPGM1' in submsg) returnsSetAssignment(bus_obj, 0, submsg.bPGM1?1:0);
	if('bPGM2' in submsg) returnsSetAssignment(bus_obj, 1, submsg.bPGM2?1:0);
	if('bPGM3' in submsg) returnsSetAssignment(bus_obj, 2, submsg.bPGM3?1:0);
	if('bPGM4' in submsg) returnsSetAssignment(bus_obj, 3, submsg.bPGM4?1:0);
}
