// ------------------------ show page ------------------------
function showPageCreate()
{
	var p;
	var f;

	p=Page_Create('show', 'glob', "PROFILE");

	if(cfg_fusionUI)
	{
		f=gui.newFrame(p.frame, 0, 37, 640, 510, "img/svg/mst_show_bg.svg");
		gui.newFrame(f, 612, 12, 20, 12, "img/svg/icon_global_options.svg");

		f.proflabel=gui.newLabel(f, 12, 12, 165, 18, '', {font:fontSemiBold(10), color:color.lgray, align:gui.RIGHT, valign:gui.MIDDLE});
		f.proflabel.setText("CURRENT PROFILE: ");
		p.profile=gui.newLabel(f, 177, 12, 350, 18, '', {font:fontSemiBold(10), color:color.lyellow, align:gui.LEFT, valign:gui.MIDDLE});
		p.list=gui.newList(f, (640-620)/2, 45, 620, 445, '', prop.list);
		p.list.setProps({border:1, barw: 3});
	}
	else
	{
		f=gui.newFrame(p.frame, 24, 103, 367, 343, "img/mst_show_bg.png");
		p.profile=gui.newLabel(f, 150, 23, 180, 14, '', prop.src_small);
		p.list=gui.newList(f, 73, 80, 218, 188, '', prop.list);
		p.list.setProps({border:1, barw: 3});
	}

// softknobs
	p.sknobs6=
	[
		{enabled: true,  rot: "SELECT", push: "TAKE", list: p.list, updn: true, jog: true, enter: true},
		{enabled: false, push: "PREVIOUS"},
		{enabled: false},
		{enabled: false},
		{enabled: false},
		{enabled: true,  push: "EXIT"}
	];
	p.sknobs3=
	[
		{enabled: true,  rot: "SELECT", push: "TAKE", list: p.list, updn: true, jog: true, enter: true},
		{enabled: false, push: "PREVIOUS"},
		{enabled: true,  push: "EXIT"}
	];

// event functions
	p.onOpen =showOnOpen;
	p.onClose=showOnClose;
	p.onSoftKnobDown=showOnSoftKnobDown;
	p.onSoftKnobUp=showOnSoftKnobUp
}
function showOnOpen(channel_nr)
{
// Indications
	mod.setMasterKeyLed(keys.MstProfile, 255);
	mod.setMasterKeyLed(keys.CmbProfile, 255);

	sknobsShow(mod.comboPresent()?this.sknobs3:this.sknobs6);

	this.profile.setText(cur_show_name);

//register receive msg handlers
	rxHandlersGlobal.showIndi=showIndi;

	var rmsg=host.sendCmsgRq({id:"READ", bSHLE:0});
	if(rmsg!=null) showPageFillList(this.list, rmsg);
	sknobsUpdate();
}
function showOnClose()
{
	sknobsHide();
//delete receive msg handlers
	delete rxHandlersGlobal.showIndi;
	mod.setMasterKeyLed(keys.MstProfile, 0);
	mod.setMasterKeyLed(keys.CmbProfile, 0);
}
function showPageFillList(list, msg)
{
	var n, tag, show;

	if(('mSHLE' in msg) && ('wSHLC' in msg))
	{
		list.hide();
		list.clear();
		for(n=1; n<=msg.wSHLC; n++)
		{
			tag=host.sprintf("m%04d", n);
			if(!(tag in msg.mSHLE)) continue;

			show=msg.mSHLE[tag];
			if(!('dSHWI' in show) || !('sSHWN' in show)) continue;

			if(show.sSHWN.charAt(0)=='.') continue; // Hidden show
			if(show.dSHWI==cur_show_id)
				list.insert(show.sSHWN, show.dSHWI, 1, 1);
			else
				list.insert(show.sSHWN, show.dSHWI, 0, 0);
		}
		list.select(0);
		list.show();
	}
}
function showIndi(msg)
{
	var p=pages.show;

	if(('mSHOW' in msg) && msg.mSHOW.id=="INDI")
	{
	// cur show name
		if('bvSHWN' in msg.mSHOW)
		{
			if(prev_show_id!=null)
			{
				sknobsSetOne(1, {enabled: true});
				sknobsSetOne(7, {enabled: true});
			}
			p.profile.setText(cur_show_name);
			setListActive(p.list, cur_show_id);
		}
	}
}
function showOnSoftKnobDown(idx)
{
	switch(idx)
	{
	case 1:
	case 7:
		host.sendNestCmsg('mSHOW', {id:"WRIN", dSHWI:this.list.selId});
		break;
	case 2:
	case 8:
		if(prev_show_id!=null)
			host.sendNestCmsg('mSHOW', {id:"WRIN", dSHWI:prev_show_id});
		break;
	}
}
function showOnSoftKnobUp(idx)
{
	switch(idx)
	{
	case 6:
	case 9: // Combo3
		closePage(this, null);
		break;
	}
}
