var setup_active=false;
var setup_phase='';
var setup_time=0;
var setup_page;
var setup_netconf;
var setup_scrres;
var setup_focus;
var setup_iptext;
var setup_mode;

function setup_exit(gui)
{
	host.cfgSetString('scr.resolution', gui);
	setup_active=false;
	setup_page.destroy();
	setup_page=null;
	setup_netconf=null;
	setup_scrres=null;
	setup_phase='done';
	gui_Create();
// Run Normal GUI here
}

function checkip(str)
{
	var a, n;
	a=str.split('.')
	if(a.length!=4) return false;
	for(n=0; n<4; n++)
	{
		if(a[n].length<1 || a[n].length>3) return false;
		if(parseInt(a[n])<0 || parseInt(a[n])>255) return false;
	}
	return true;
}
function str2ip(str)
{
	var a=str.split('.');
	if(a.length!=4) return 0;
	return parseInt(a[0])|(parseInt(a[1])<<8)|(parseInt(a[2])<<16)|(parseInt(a[3])<<24);
}
function ip2str(ip)
{
	return (ip&0xFF)+'.'+((ip>>8)&0xFF)+'.'+((ip>>16)&0xFF)+'.'+((ip>>24)&0xFF);
}
function setup_address_field(f, x, y, lbl)
{
	var p;
	p=gui.newLabel(f, x-120, y, 120, 18, '', {font:fontSemiBold(10), color:gui.rgb(255,255,255), align:gui.RIGHT, valign:gui.MIDDLE});
	p.setText(lbl);
	p.val=gui.newLabel(f, x+5, y, 220, 18, '', {font:fontSemiBold(10), color:gui.rgb(255,255,255), align:gui.LEFT, valign:gui.MIDDLE});
	return p;
}

function setup_tick()
{
	var n;
	if(!setup_active) return;

	var lst=host.getVerInfo();
	setup_page.list.clear();
	setup_page.list.insert("Component\tId\tVersion\t\tConn", 0, 0, 2);
	for(n=0; n<lst.length; n++)
	{
		if((lst[n].indexOf("Master")>=0 || lst[n].indexOf("Combo")>=0) && lst[n].indexOf("usb")>=0)
		{
			host.sleep(1000); // sleep just a little while to allow other modules to catch-up */
			mod.enterCapture(true);
		/* we have detected a locally connected console, get into the Element mode */
			setup_exit((setup_scrres.h!=0 && (setup_scrres.w/setup_scrres.h)>1.5)?'720p':'XGA');
			return;
		}
		setup_page.list.insert(lst[n]);
	}

	if(setup_phase=='wait' || setup_phase=='wait_resp')
	{
		if(setup_time<=1)
		{
			setup_phase='wait_resp';
			host.bootpSendRequest();
			setup_time=20;
		}
		else
			setup_time--;
		if(setup_phase=='wait_resp')
			setup_page.message.setText("Bootp request sent, waiting for response. Retry in "+setup_time+" seconds.");
		else
			setup_page.message.setText("Bootp request will be sent after "+setup_time+" seconds. Press any key to abort.");
	}
	else if(setup_phase=='wait_apply')
	{
		if(setup_time==0)
		{
			setup_phase='reboot';
			host.cfgSetString('scr.resolution', '1080p');
			host.setNetSetup(setup_netconf);
			setup_page.sv.val.setText("Saved. Rebooting.");
		}
		else
		{
			setup_page.sv.val.setText("Save in "+setup_time+" seconds.");
			setup_time--;
		}
	}
	else if(setup_phase=='reboot')
	{
		host.reboot();
		return;
	}
	host.setTimeout(1000, setup_tick, null);
}

function setup_update_addrtxt()
{
	var a=[setup_page.ip.val, setup_page.nm.val, setup_page.gw.val, setup_page.md.val, setup_page.sv.val];
	var n;
	
	for(n=0; n<3; n++)
	{
		a[n].setText(setup_iptext[n]+((setup_focus==n)?'_':''));
		a[n].setProp("color", (setup_focus==n)?"yellow":(checkip(setup_iptext[n])?"white":"red"));
	}
	a[3].setText((setup_mode=='XGA')?"Element":((setup_mode=='720p')?"Element Wide":((setup_mode=='1080p')?"Fusion":"")));
	a[3].setProp("color", (setup_focus==3)?"yellow":"white");
	a[4].setText((setup_focus<0)?"-":"Save & Reboot");
	a[4].setProp("color", (setup_focus==4)?"yellow":"white");
}

function setup_keyevent(x, y, key)
{
	if(!setup_active) return;
	if(setup_phase!='manual')
	{
		setup_phase='manual';
		setup_time=0;
		setup_page.message.setText("Bootp request aborted. Enter ip address. Up/Dn navigate. Backspace - erase. Lt/Rt - change mode.");
		setup_focus=0;
		setup_update_addrtxt();
		return;
	}

	switch(key)
	{
	case 1002: // Up
		if(setup_focus>0)
		{
			setup_focus--;
			setup_update_addrtxt();
		}
		break;
	case 1003: // Down
		if(setup_focus<4)
		{
			setup_focus++;
			setup_update_addrtxt();
		}
		break;
	case 13:
		if(setup_focus<4)
		{
			setup_focus++;
			setup_update_addrtxt();
		}
		else if(setup_focus==4)
		{
			if(checkip(setup_iptext[0])) setup_netconf.ipaddr =str2ip(setup_iptext[0]); else break;
			if(checkip(setup_iptext[1])) setup_netconf.netmask=str2ip(setup_iptext[1]); else break;
			if(checkip(setup_iptext[2])) setup_netconf.gateway=str2ip(setup_iptext[2]); else break;
		/* save & reboot */
			setup_phase='reboot';
			host.cfgSetString('scr.resolution', setup_mode);
			host.setNetSetup(setup_netconf);
			setup_page.sv.val.setText("Saved. Rebooting.");
		}
		break;
	default:
		if(setup_focus>=0 && setup_focus<3)
		{
			if(key==8)
			{
				if(setup_iptext[setup_focus].length>0)
				{
					setup_iptext[setup_focus]=setup_iptext[setup_focus].substr(0, setup_iptext[setup_focus].length-1);
					setup_update_addrtxt();
				}
			}
			else if((key>=48 && key<=57) || key==46)
			{
				if(setup_iptext[setup_focus].length<16)
				{
					setup_iptext[setup_focus]+=String.fromCharCode(key);
					setup_update_addrtxt();
				}
			}
		}
		else if(setup_focus==3)
		{
			if(key==1000) // Left
			{
				switch(setup_mode)
				{
				case '1080p': setup_mode='720p'; setup_update_addrtxt(); break;
				case '720p' : setup_mode='XGA' ; setup_update_addrtxt(); break;
				}
			}
			else if(key==1001) // Right
			{
				switch(setup_mode)
				{
				case 'XGA' : setup_mode='720p' ; setup_update_addrtxt(); break;
				case '720p': setup_mode='1080p'; setup_update_addrtxt(); break;
				}
			}
		}

		return;
	}
}

function onBootpMsg(netconf)
{
	if(setup_active && setup_phase=='wait_resp')
	{
		setup_netconf=netconf;
		setup_phase='wait_apply';
		setup_time=5;
		setup_page.message.setText("Bootp response received ip="+ip2str(netconf.ipaddr)+" nm="+ip2str(netconf.netmask)+" gw="+ip2str(netconf.gateway));
		setup_iptext=[ip2str(setup_netconf.ipaddr), ip2str(setup_netconf.netmask), ip2str(setup_netconf.gateway)];
		setup_update_addrtxt();
	}
}

function setup_begin()
{
	if(setup_phase=='done') return false; /* this is to avoid recusrion if something goes wrong */
/*
 This is a setup screen that will be shown in case of no configuration is defined
 Purpose of the screen is to define following items:
  1. System GUI style resolution. Detection is by connected monitor.
  2. IP address
  3. eth4can detection and ip address push
  4. fader config capture
*/
	setup_active=true;
	setup_time=20; // seconds to the next bootp request
	setup_phase='wait';
	setup_netconf=host.getNetSetup();
	setup_scrres=gui.getScreenRes();
	setup_iptext=[];
	setup_focus=-1;
// before setting resolution, get native monitor resolution if possible
	gui.init(1024, 768);
	gui.setBgColor(gui.rgb(67,83,112));

	setup_page=gui.newFrame(null, 0, 0, 1024, 768, '');
	setup_page.title=gui.newLabel(setup_page, 462, 40, 100, 18, '', {font:fontSemiBold(12), color:gui.rgb(255,255,255), align:gui.CENTER, valign:gui.MIDDLE});
	setup_page.title.setText("System Setup");

	setup_page.id=setup_address_field(setup_page, 512, 100, "Unit id:");
	setup_page.id.val.setText(host.getIdentity());
	setup_page.id=setup_address_field(setup_page, 512, 120, "Unit MAC:");
	setup_page.id.val.setText(host.getMAC());
	setup_page.id=setup_address_field(setup_page, 512, 140, "Connected Screen:");
	setup_page.id.val.setText(setup_scrres.w+"x"+setup_scrres.h);

	setup_page.ip=setup_address_field(setup_page, 512, 160, "Config IP addr:");
	setup_page.nm=setup_address_field(setup_page, 512, 180, "Config Netmask:");
	setup_page.gw=setup_address_field(setup_page, 512, 200, "Config Gateway:");
	setup_page.md=setup_address_field(setup_page, 512, 220, "Config Mode:");
	setup_page.sv=setup_address_field(setup_page, 512, 240, "Save:");

	setup_iptext=[ip2str(setup_netconf.ipaddr), ip2str(setup_netconf.netmask), ip2str(setup_netconf.gateway)];
	if(1) // We default to 1080p Fusion for marketing reasons (setup_scrres.w==1920 && setup_scrres.h==1080)
		setup_mode='1080p';
	else if((setup_scrres.h!=0 && (setup_scrres.w/setup_scrres.h)>1.5))
		setup_mode='720p';
	else
		setup_mode='XGA';
	setup_update_addrtxt();

	setup_page.message=gui.newLabel(setup_page, 100, 460, 824, 18, '', {font:fontSemiBold(12), color:gui.rgb(255,255,255), align:gui.CENTER, valign:gui.MIDDLE});

	setup_page.list=gui.newList(setup_page, 200, 500, 510, 268, '', {font: fontSemiBold(10), color:gui.rgb(255,255,255)});
	setup_page.list.setColumns([200, 40, 100, 100, 50]);

	setup_page.onKeyEvent=setup_keyevent;
	setup_page.setInput(true);

	setup_tick();
	return true;
}


